#only for Python2.5 and later
from RoBoIO_Python import *

if __name__ == "__main__":

    #first set the correct RoBoard version
    roboio_SetRBVer(RB_100)
    #roboio_SetRBVer(RB_110)    #if your RoBoard is RB-110
    #roboio_SetRBVer(RB_050)    #if your RoBoard is RB-050
    #roboio_SetRBVer(RB_100RD)  #if your RoBoard is RB-100RD

    if not spi_Init(SPICLK_21400KHZ):    #init SPI lib for accessing the A/D converter
        print "ERROR: fail to init SPI lib (", roboio_GetErrMsg(), ")!"
        exit()

    for i in range(8):
        val = adc_ReadCH(i)    #read the ADC input value on channel i
        if val == ADC_READFAIL:
            print "ERROR : fail to read ADC value on channel", i
        else:
            print "ADC value on channel", i, "=", val

    spi_Close()
