#only for Python2.5 and later
from RoBoIO_Python import *

if __name__ == "__main__":

    #first set the correct RoBoard version
    roboio_SetRBVer(RB_100)
    #roboio_SetRBVer(RB_110)    #if your RoBoard is RB-110
    #roboio_SetRBVer(RB_050)    #if your RoBoard is RB-050
    #roboio_SetRBVer(RB_100RD)  #if your RoBoard is RB-100RD

    if not rcservo_Init(RCSERVO_USENOPIN):    #set all PWM/GPIO pins as GPIO mode
        print "ERROR: fail to init RC Servo lib (", roboio_GetErrMsg(), ")!"
        exit()

    print "Press ENTER to read digital input on pin S1..."
    raw_input()
    val = rcservo_InPin(RCSERVO_PINS1)

    if val == 0:
        print "The result = LOW"
    else:
        print "The result = HIGH"

    print "Press ENTER to output HIGH on pin S2..."
    raw_input()
    rcservo_OutPin(RCSERVO_PINS2, 1)
    print "now you should get HIGH when measuring pin S2"

    print "Press ENTER to output LOW on pin S2..."
    raw_input()
    rcservo_OutPin(RCSERVO_PINS2, 0)
    print "now you should get LOW when measuring pin S2"

    rcservo_Close()    #close RC Servo lib
