from ctypes import *
RoBoIO = WinDLL("RoBoIO.dll")
#common.h
ERR_NOERROR = (0)
RoBoIO.roboio_GetErrCode.argtypes = None
RoBoIO.roboio_GetErrCode.restype = c_int
roboio_GetErrCode = RoBoIO.roboio_GetErrCode

RoBoIO.roboio_GetErrMsg.argtypes = None
RoBoIO.roboio_GetErrMsg.restype = c_char_p
roboio_GetErrMsg = RoBoIO.roboio_GetErrMsg

RoBoIO.err_SetLogFile.argtypes = [c_char_p]
RoBoIO.err_SetLogFile.restype = c_bool
err_SetLogFile = RoBoIO.err_SetLogFile

RoBoIO.err_CloseLogFile.argtypes = None
RoBoIO.err_CloseLogFile.restype = None
err_CloseLogFile = RoBoIO.err_CloseLogFile

RoBoIO.roboio_SetRBVer.argtypes = [c_int]
RoBoIO.roboio_SetRBVer.restype = c_bool
roboio_SetRBVer = RoBoIO.roboio_SetRBVer

RB_100b1 = (98)
RB_100b2 = (99)
RB_100b3 = (97)
RB_100 = (100)
RB_100RD = (101)
RB_110 = (110)
RB_050 = (50)
ERROR_RBVER_UNMATCH = (ERR_NOERROR + 800)
ERROR_RBVER_UNKNOWN = (ERR_NOERROR + 801)
#ad79x8.h
AD79x8_READFAIL = (0x7fff)
RoBoIO.ad79x8_RawRead.argtypes = None
RoBoIO.ad79x8_RawRead.restype = c_uint
ad79x8_RawRead = RoBoIO.ad79x8_RawRead

ERROR_ADCFAIL = (ERR_NOERROR + 510)
RoBoIO.ad79x8_RawWrite.argtypes = [c_uint]
RoBoIO.ad79x8_RawWrite.restype = c_bool
ad79x8_RawWrite = RoBoIO.ad79x8_RawWrite

RoBoIO.ad79x8_WriteCTRLREG.argtypes = [c_uint]
RoBoIO.ad79x8_WriteCTRLREG.restype = c_bool
ad79x8_WriteCTRLREG = RoBoIO.ad79x8_WriteCTRLREG

RoBoIO.ad79x8_InUse.argtypes = None
RoBoIO.ad79x8_InUse.restype = c_bool
ad79x8_InUse = RoBoIO.ad79x8_InUse

RoBoIO.ad79x8_Initialize.argtypes = [c_int, c_int, c_int]
RoBoIO.ad79x8_Initialize.restype = c_bool
ad79x8_Initialize = RoBoIO.ad79x8_Initialize

AD79x8MODE_RANGE_VREF = (0)
AD79x8MODE_RANGE_2VREF = (1)
AD79x8MODE_CODING_UNSIGNED = (0)
AD79x8MODE_CODING_SIGNED = (1)
ERROR_ADC_NOSPI = (ERR_NOERROR + 531)
ERROR_ADC_INUSE = (ERR_NOERROR + 532)
ERROR_ADC_WRONGCHANNEL = (ERR_NOERROR + 511)
RoBoIO.ad79x8_Close.argtypes = None
RoBoIO.ad79x8_Close.restype = c_bool
ad79x8_Close = RoBoIO.ad79x8_Close

RoBoIO.ad79x8_ChangeChannel.argtypes = [c_int, c_int, c_int]
RoBoIO.ad79x8_ChangeChannel.restype = c_bool
ad79x8_ChangeChannel = RoBoIO.ad79x8_ChangeChannel

RoBoIO.ad79x8_InitializeMCH.argtypes = [c_ubyte, c_int, c_int]
RoBoIO.ad79x8_InitializeMCH.restype = c_bool
ad79x8_InitializeMCH = RoBoIO.ad79x8_InitializeMCH

AD79x8_USECHANNEL0 = (1<<7)
AD79x8_USECHANNEL1 = (1<<6)
AD79x8_USECHANNEL2 = (1<<5)
AD79x8_USECHANNEL3 = (1<<4)
AD79x8_USECHANNEL4 = (1<<3)
AD79x8_USECHANNEL5 = (1<<2)
AD79x8_USECHANNEL6 = (1<<1)
AD79x8_USECHANNEL7 = (1<<0)
RoBoIO.ad79x8_ChangeChannels.argtypes = [c_ubyte, c_int, c_int]
RoBoIO.ad79x8_ChangeChannels.restype = c_bool
ad79x8_ChangeChannels = RoBoIO.ad79x8_ChangeChannels

ADC_READFAIL = (AD79x8_READFAIL)
RoBoIO.adc_ReadChannel.argtypes = [c_int, c_int, c_int]
RoBoIO.adc_ReadChannel.restype = c_int
adc_ReadChannel = RoBoIO.adc_ReadChannel

ADCMODE_RANGE_VREF = (AD79x8MODE_RANGE_VREF)
ADCMODE_RANGE_2VREF = (AD79x8MODE_RANGE_2VREF)
ADCMODE_UNSIGNEDCODING = (AD79x8MODE_CODING_UNSIGNED)
ADCMODE_SIGNEDCODING = (AD79x8MODE_CODING_SIGNED)
RoBoIO.adc_Read.argtypes = None
RoBoIO.adc_Read.restype = c_int
adc_Read = RoBoIO.adc_Read

ADC_USECHANNEL0 = (AD79x8_USECHANNEL0)
ADC_USECHANNEL1 = (AD79x8_USECHANNEL1)
ADC_USECHANNEL2 = (AD79x8_USECHANNEL2)
ADC_USECHANNEL3 = (AD79x8_USECHANNEL3)
ADC_USECHANNEL4 = (AD79x8_USECHANNEL4)
ADC_USECHANNEL5 = (AD79x8_USECHANNEL5)
ADC_USECHANNEL6 = (AD79x8_USECHANNEL6)
ADC_USECHANNEL7 = (AD79x8_USECHANNEL7)
RoBoIO.adc_ReadMCH.argtypes = None
RoBoIO.adc_ReadMCH.restype = POINTER(c_void_p)
adc_ReadMCH = RoBoIO.adc_ReadMCH

RoBoIO.adc_ReadMCH2.argtypes = [c_void_p]
RoBoIO.adc_ReadMCH2.restype = None
#adc_ReadMCH2 = RoBoIO.adc_ReadMCH2
def adc_ReadMCH2(buf):
    if len(buf)<8:
        for i in range(len(buf), 8):
            buf.append(0)
    cint = c_int * 8
    temp = cint()
    RoBoIO.adc_ReadMCH2(temp)
    for i in range(8):
        buf[i] = temp[i]

AD7908_READFAIL = (AD79x8_READFAIL)
RoBoIO.ad7908_ReadChannel.argtypes = [c_int, c_int, c_int]
RoBoIO.ad7908_ReadChannel.restype = c_int
ad7908_ReadChannel = RoBoIO.ad7908_ReadChannel

AD7908MODE_RANGE_VREF = (AD79x8MODE_RANGE_VREF)
AD7908MODE_RANGE_2VREF = (AD79x8MODE_RANGE_2VREF)
AD7908MODE_CODING_255 = (AD79x8MODE_CODING_UNSIGNED)
AD7908MODE_CODING_127 = (AD79x8MODE_CODING_SIGNED)
RoBoIO.ad7908_Read.argtypes = None
RoBoIO.ad7908_Read.restype = c_int
ad7908_Read = RoBoIO.ad7908_Read

AD7908_USECHANNEL0 = (AD79x8_USECHANNEL0)
AD7908_USECHANNEL1 = (AD79x8_USECHANNEL1)
AD7908_USECHANNEL2 = (AD79x8_USECHANNEL2)
AD7908_USECHANNEL3 = (AD79x8_USECHANNEL3)
AD7908_USECHANNEL4 = (AD79x8_USECHANNEL4)
AD7908_USECHANNEL5 = (AD79x8_USECHANNEL5)
AD7908_USECHANNEL6 = (AD79x8_USECHANNEL6)
AD7908_USECHANNEL7 = (AD79x8_USECHANNEL7)
RoBoIO.ad7908_ReadMCH.argtypes = None
RoBoIO.ad7908_ReadMCH.restype = POINTER(c_void_p)
ad7908_ReadMCH = RoBoIO.ad7908_ReadMCH

RoBoIO.ad7908_ReadMCH2.argtypes = [c_void_p]
RoBoIO.ad7908_ReadMCH2.restype = None
#ad7908_ReadMCH2 = RoBoIO.ad7908_ReadMCH2
def ad7908_ReadMCH2(buf):
    if len(buf)<8:
        for i in range(len(buf), 8):
            buf.append(0)
    cint = c_int * 8
    temp = cint()
    RoBoIO.ad7908_ReadMCH2(temp)
    for i in range(8):
        buf[i] = temp[i]

AD7918_READFAIL = (AD79x8_READFAIL)
RoBoIO.ad7918_ReadChannel.argtypes = [c_int, c_int, c_int]
RoBoIO.ad7918_ReadChannel.restype = c_int
ad7918_ReadChannel = RoBoIO.ad7918_ReadChannel

AD7918MODE_RANGE_VREF = (AD79x8MODE_RANGE_VREF)
AD7918MODE_RANGE_2VREF = (AD79x8MODE_RANGE_2VREF)
AD7918MODE_CODING_1023 = (AD79x8MODE_CODING_UNSIGNED)
AD7918MODE_CODING_511 = (AD79x8MODE_CODING_SIGNED)
RoBoIO.ad7918_Read.argtypes = None
RoBoIO.ad7918_Read.restype = c_int
ad7918_Read = RoBoIO.ad7918_Read

AD7918_USECHANNEL0 = (AD79x8_USECHANNEL0)
AD7918_USECHANNEL1 = (AD79x8_USECHANNEL1)
AD7918_USECHANNEL2 = (AD79x8_USECHANNEL2)
AD7918_USECHANNEL3 = (AD79x8_USECHANNEL3)
AD7918_USECHANNEL4 = (AD79x8_USECHANNEL4)
AD7918_USECHANNEL5 = (AD79x8_USECHANNEL5)
AD7918_USECHANNEL6 = (AD79x8_USECHANNEL6)
AD7918_USECHANNEL7 = (AD79x8_USECHANNEL7)
RoBoIO.ad7918_ReadMCH.argtypes = None
RoBoIO.ad7918_ReadMCH.restype = POINTER(c_void_p)
ad7918_ReadMCH = RoBoIO.ad7918_ReadMCH

RoBoIO.ad7918_ReadMCH2.argtypes = [c_void_p]
RoBoIO.ad7918_ReadMCH2.restype = None
#ad7918_ReadMCH2 = RoBoIO.ad7918_ReadMCH2
def ad7918_ReadMCH2(buf):
    if len(buf)<8:
        for i in range(len(buf), 8):
            buf.append(0)
    cint = c_int * 8
    temp = cint()
    RoBoIO.ad7918_ReadMCH2(temp)
    for i in range(8):
        buf[i] = temp[i]

AD7928_READFAIL = (AD79x8_READFAIL)
RoBoIO.ad7928_ReadChannel.argtypes = [c_int, c_int, c_int]
RoBoIO.ad7928_ReadChannel.restype = c_int
ad7928_ReadChannel = RoBoIO.ad7928_ReadChannel

AD7928MODE_RANGE_VREF = (AD79x8MODE_RANGE_VREF)
AD7928MODE_RANGE_2VREF = (AD79x8MODE_RANGE_2VREF)
AD7928MODE_CODING_4095 = (AD79x8MODE_CODING_UNSIGNED)
AD7928MODE_CODING_2047 = (AD79x8MODE_CODING_SIGNED)
RoBoIO.ad7928_Read.argtypes = None
RoBoIO.ad7928_Read.restype = c_int
ad7928_Read = RoBoIO.ad7928_Read

AD7928_USECHANNEL0 = (AD79x8_USECHANNEL0)
AD7928_USECHANNEL1 = (AD79x8_USECHANNEL1)
AD7928_USECHANNEL2 = (AD79x8_USECHANNEL2)
AD7928_USECHANNEL3 = (AD79x8_USECHANNEL3)
AD7928_USECHANNEL4 = (AD79x8_USECHANNEL4)
AD7928_USECHANNEL5 = (AD79x8_USECHANNEL5)
AD7928_USECHANNEL6 = (AD79x8_USECHANNEL6)
AD7928_USECHANNEL7 = (AD79x8_USECHANNEL7)
RoBoIO.ad7928_ReadMCH.argtypes = None
RoBoIO.ad7928_ReadMCH.restype = POINTER(c_void_p)
ad7928_ReadMCH = RoBoIO.ad7928_ReadMCH

RoBoIO.ad7928_ReadMCH2.argtypes = [c_void_p]
RoBoIO.ad7928_ReadMCH2.restype = None
#ad7928_ReadMCH2 = RoBoIO.ad7928_ReadMCH2
def ad7928_ReadMCH2(buf):
    if len(buf)<8:
        for i in range(len(buf), 8):
            buf.append(0)
    cint = c_int * 8
    temp = cint()
    RoBoIO.ad7928_ReadMCH2(temp)
    for i in range(8):
        buf[i] = temp[i]

RoBoIO.adc_InUse.argtypes = None
RoBoIO.adc_InUse.restype = c_bool
adc_InUse = RoBoIO.adc_InUse

RoBoIO.adc_Init.argtypes = [c_int, c_int, c_int]
RoBoIO.adc_Init.restype = c_bool
adc_Init = RoBoIO.adc_Init

RoBoIO.adc_Close.argtypes = None
RoBoIO.adc_Close.restype = c_bool
adc_Close = RoBoIO.adc_Close

RoBoIO.adc_ChangeChannel.argtypes = [c_int, c_int, c_int]
RoBoIO.adc_ChangeChannel.restype = c_bool
adc_ChangeChannel = RoBoIO.adc_ChangeChannel

RoBoIO.adc_InitMCH.argtypes = [c_ubyte, c_int, c_int]
RoBoIO.adc_InitMCH.restype = c_bool
adc_InitMCH = RoBoIO.adc_InitMCH

RoBoIO.adc_CloseMCH.argtypes = None
RoBoIO.adc_CloseMCH.restype = c_bool
adc_CloseMCH = RoBoIO.adc_CloseMCH

RoBoIO.adc_ChangeChannels.argtypes = [c_ubyte, c_int, c_int]
RoBoIO.adc_ChangeChannels.restype = c_bool
adc_ChangeChannels = RoBoIO.adc_ChangeChannels

RoBoIO.adc_ReadCH.argtypes = [c_int]
RoBoIO.adc_ReadCH.restype = c_int
adc_ReadCH = RoBoIO.adc_ReadCH

RoBoIO.ad7908_Initialize.argtypes = [c_int, c_int, c_int]
RoBoIO.ad7908_Initialize.restype = c_bool
ad7908_Initialize = RoBoIO.ad7908_Initialize

RoBoIO.ad7908_InitializeMCH.argtypes = [c_ubyte, c_int, c_int]
RoBoIO.ad7908_InitializeMCH.restype = c_bool
ad7908_InitializeMCH = RoBoIO.ad7908_InitializeMCH

RoBoIO.ad7918_Initialize.argtypes = [c_int, c_int, c_int]
RoBoIO.ad7918_Initialize.restype = c_bool
ad7918_Initialize = RoBoIO.ad7918_Initialize

RoBoIO.ad7918_InitializeMCH.argtypes = [c_ubyte, c_int, c_int]
RoBoIO.ad7918_InitializeMCH.restype = c_bool
ad7918_InitializeMCH = RoBoIO.ad7918_InitializeMCH

RoBoIO.ad7928_Initialize.argtypes = [c_int, c_int, c_int]
RoBoIO.ad7928_Initialize.restype = c_bool
ad7928_Initialize = RoBoIO.ad7928_Initialize

RoBoIO.ad7928_InitializeMCH.argtypes = [c_ubyte, c_int, c_int]
RoBoIO.ad7928_InitializeMCH.restype = c_bool
ad7928_InitializeMCH = RoBoIO.ad7928_InitializeMCH

RoBoIO.adc_Initialize.argtypes = [c_int, c_int, c_int]
RoBoIO.adc_Initialize.restype = c_bool
adc_Initialize = RoBoIO.adc_Initialize

RoBoIO.adc_InitializeMCH.argtypes = [c_ubyte, c_int, c_int]
RoBoIO.adc_InitializeMCH.restype = c_bool
adc_InitializeMCH = RoBoIO.adc_InitializeMCH

RoBoIO.ad7908_InUse.argtypes = None
RoBoIO.ad7908_InUse.restype = c_bool
ad7908_InUse = RoBoIO.ad7908_InUse

RoBoIO.ad7918_InUse.argtypes = None
RoBoIO.ad7918_InUse.restype = c_bool
ad7918_InUse = RoBoIO.ad7918_InUse

RoBoIO.ad7928_InUse.argtypes = None
RoBoIO.ad7928_InUse.restype = c_bool
ad7928_InUse = RoBoIO.ad7928_InUse

RoBoIO.ad7908_Init.argtypes = [c_int, c_int, c_int]
RoBoIO.ad7908_Init.restype = c_bool
ad7908_Init = RoBoIO.ad7908_Init

RoBoIO.ad7918_Init.argtypes = [c_int, c_int, c_int]
RoBoIO.ad7918_Init.restype = c_bool
ad7918_Init = RoBoIO.ad7918_Init

RoBoIO.ad7928_Init.argtypes = [c_int, c_int, c_int]
RoBoIO.ad7928_Init.restype = c_bool
ad7928_Init = RoBoIO.ad7928_Init

RoBoIO.ad7908_Close.argtypes = None
RoBoIO.ad7908_Close.restype = c_bool
ad7908_Close = RoBoIO.ad7908_Close

RoBoIO.ad7918_Close.argtypes = None
RoBoIO.ad7918_Close.restype = c_bool
ad7918_Close = RoBoIO.ad7918_Close

RoBoIO.ad7928_Close.argtypes = None
RoBoIO.ad7928_Close.restype = c_bool
ad7928_Close = RoBoIO.ad7928_Close

RoBoIO.ad7908_ChangeChannel.argtypes = [c_int, c_int, c_int]
RoBoIO.ad7908_ChangeChannel.restype = c_bool
ad7908_ChangeChannel = RoBoIO.ad7908_ChangeChannel

RoBoIO.ad7918_ChangeChannel.argtypes = [c_int, c_int, c_int]
RoBoIO.ad7918_ChangeChannel.restype = c_bool
ad7918_ChangeChannel = RoBoIO.ad7918_ChangeChannel

RoBoIO.ad7928_ChangeChannel.argtypes = [c_int, c_int, c_int]
RoBoIO.ad7928_ChangeChannel.restype = c_bool
ad7928_ChangeChannel = RoBoIO.ad7928_ChangeChannel

RoBoIO.ad7908_InitMCH.argtypes = [c_ubyte, c_int, c_int]
RoBoIO.ad7908_InitMCH.restype = c_bool
ad7908_InitMCH = RoBoIO.ad7908_InitMCH

RoBoIO.ad7918_InitMCH.argtypes = [c_ubyte, c_int, c_int]
RoBoIO.ad7918_InitMCH.restype = c_bool
ad7918_InitMCH = RoBoIO.ad7918_InitMCH

RoBoIO.ad7928_InitMCH.argtypes = [c_ubyte, c_int, c_int]
RoBoIO.ad7928_InitMCH.restype = c_bool
ad7928_InitMCH = RoBoIO.ad7928_InitMCH

RoBoIO.ad7908_CloseMCH.argtypes = None
RoBoIO.ad7908_CloseMCH.restype = c_bool
ad7908_CloseMCH = RoBoIO.ad7908_CloseMCH

RoBoIO.ad7918_CloseMCH.argtypes = None
RoBoIO.ad7918_CloseMCH.restype = c_bool
ad7918_CloseMCH = RoBoIO.ad7918_CloseMCH

RoBoIO.ad7928_CloseMCH.argtypes = None
RoBoIO.ad7928_CloseMCH.restype = c_bool
ad7928_CloseMCH = RoBoIO.ad7928_CloseMCH

RoBoIO.ad7908_ChangeChannels.argtypes = [c_ubyte, c_int, c_int]
RoBoIO.ad7908_ChangeChannels.restype = c_bool
ad7908_ChangeChannels = RoBoIO.ad7908_ChangeChannels

RoBoIO.ad7918_ChangeChannels.argtypes = [c_ubyte, c_int, c_int]
RoBoIO.ad7918_ChangeChannels.restype = c_bool
ad7918_ChangeChannels = RoBoIO.ad7918_ChangeChannels

RoBoIO.ad7928_ChangeChannels.argtypes = [c_ubyte, c_int, c_int]
RoBoIO.ad7928_ChangeChannels.restype = c_bool
ad7928_ChangeChannels = RoBoIO.ad7928_ChangeChannels

#com.h
RoBoIO.com_InUse.argtypes = [c_int]
RoBoIO.com_InUse.restype = c_bool
com_InUse = RoBoIO.com_InUse

RoBoIO.com_Init.argtypes = [c_int, c_int]
RoBoIO.com_Init.restype = c_bool
com_Init = RoBoIO.com_Init

COM_PORT1 = (0)
COM_PORT2 = (1)
COM_PORT3 = (2)
COM_PORT4 = (3)
COM_ADUPLEX = (0xff)
COM_FDUPLEX = (0)
COM_HDUPLEX = (1)
COM_HDUPLEX_RTS = (2)
COM_HDUPLEX_TXDEN = (3)
ERROR_COM_INUSE = (ERR_NOERROR + 700)
ERROR_COM_INVALID = (ERR_NOERROR + 702)
ERROR_COM_FAIL = (ERR_NOERROR + 704)
RoBoIO.com_Close.argtypes = [c_int]
RoBoIO.com_Close.restype = None
com_Close = RoBoIO.com_Close

RoBoIO.com_SetFormat.argtypes = [c_int, c_int, c_int, c_int]
RoBoIO.com_SetFormat.restype = c_bool
com_SetFormat = RoBoIO.com_SetFormat

COM_BYTESIZE5 = (5)
COM_BYTESIZE6 = (6)
COM_BYTESIZE7 = (7)
COM_BYTESIZE8 = (8)
COM_STOPBIT1 = (1)
COM_STOPBIT2 = (2)
COM_NOPARITY = (0)
COM_ODDPARITY = (1)
COM_EVENPARITY = (2)
RoBoIO.com_SetBaud.argtypes = [c_int, c_uint]
RoBoIO.com_SetBaud.restype = c_bool
com_SetBaud = RoBoIO.com_SetBaud

COMBAUD_748800BPS = (0x8002)
COMBAUD_499200BPS = (0x8003)
COMBAUD_249600BPS = (0x8006)
COMBAUD_115200BPS = (0x0001)
COMBAUD_57600BPS = (0x0002)
COMBAUD_38400BPS = (0x0003)
COMBAUD_19200BPS = (0x0006)
COMBAUD_9600BPS = (0x000c)
COMBAUD_4800BPS = (0x0018)
COMBAUD_2400BPS = (0x0030)
COMBAUD_1200BPS = (0x0060)
COMBAUD_300BPS = (0x0180)
COMBAUD_50BPS = (0x0900)
RoBoIO.com_Receive.argtypes = [c_int, c_void_p, c_int]
RoBoIO.com_Receive.restype = c_bool
#com_Receive = RoBoIO.com_Receive
def com_Receive(com, buf, bsize):
    if len(buf)<bsize:
        for i in range(len(buf), bsize):
            buf.append(0)
    ubyte = c_ubyte * bsize
    temp = ubyte()
    if not RoBoIO.com_Receive(com, temp, bsize):
        return False
    for i in range(bsize):
        buf[i] = temp[i]
    return True

ERROR_COM_READFAIL = (ERR_NOERROR + 720)
RoBoIO.com_Read.argtypes = [c_int]
RoBoIO.com_Read.restype = c_uint
com_Read = RoBoIO.com_Read

RoBoIO.com_ClearRFIFO.argtypes = [c_int]
RoBoIO.com_ClearRFIFO.restype = c_bool
com_ClearRFIFO = RoBoIO.com_ClearRFIFO

RoBoIO.com_QueryRFIFO.argtypes = [c_int]
RoBoIO.com_QueryRFIFO.restype = c_int
com_QueryRFIFO = RoBoIO.com_QueryRFIFO

RoBoIO.com_Send.argtypes = [c_int, c_void_p, c_int]
RoBoIO.com_Send.restype = c_bool
#com_Send = RoBoIO.com_Send
def com_Send(com, buf, bsize):
    ubyte = c_ubyte * bsize
    temp = ubyte()
    for i in range(min(len(buf), bsize)):
        temp[i] = buf[i]
    if not RoBoIO.com_Send(come, temp, bsize):
        return False
    return True    

RoBoIO.com_Write.argtypes = [c_int, c_ubyte]
RoBoIO.com_Write.restype = c_bool
com_Write = RoBoIO.com_Write

ERROR_COM_SENDFAIL = (ERR_NOERROR + 730)
RoBoIO.com_FlushWFIFO.argtypes = [c_int]
RoBoIO.com_FlushWFIFO.restype = c_bool
com_FlushWFIFO = RoBoIO.com_FlushWFIFO

RoBoIO.com_ClearWFIFO.argtypes = [c_int]
RoBoIO.com_ClearWFIFO.restype = c_bool
com_ClearWFIFO = RoBoIO.com_ClearWFIFO

RoBoIO.com_ServoTRX.argtypes = [c_int, c_void_p, c_int, c_void_p, c_int]
RoBoIO.com_ServoTRX.restype = c_bool
#com_ServoTRX = RoBoIO.com_ServoTRX
def com_ServoTRX(com, cmd, csize, buf, bsize):
    if len(buf)<bsize:
        for i in range(len(buf), bsize):
            buf.append(0)
    ubyte2 = c_type * csize
    temp = ubyte2()	
    ubyte = c_ubyte * bsize
    temp2 = ubyte()
    for i in range(min(len(cmd), csize)):
        temp[i] = cmd[i]
    if not RoBoIO.com_ServoTRX(com, temp, csize, temp2, bsize):
        return False
    for i in range(bsize):
        buf[i] = temp2[i]
    return True 

RoBoIO.com_EnableTurboMode.argtypes = [c_int]
RoBoIO.com_EnableTurboMode.restype = None
com_EnableTurboMode = RoBoIO.com_EnableTurboMode

RoBoIO.com_DisableTurboMode.argtypes = [c_int]
RoBoIO.com_DisableTurboMode.restype = None
com_DisableTurboMode = RoBoIO.com_DisableTurboMode

RoBoIO.com_IsTurboMode.argtypes = [c_int]
RoBoIO.com_IsTurboMode.restype = c_bool
com_IsTurboMode = RoBoIO.com_IsTurboMode

RoBoIO.com_EnableFIFO32.argtypes = [c_int]
RoBoIO.com_EnableFIFO32.restype = None
com_EnableFIFO32 = RoBoIO.com_EnableFIFO32

RoBoIO.com_DisableFIFO32.argtypes = [c_int]
RoBoIO.com_DisableFIFO32.restype = None
com_DisableFIFO32 = RoBoIO.com_DisableFIFO32

RoBoIO.com_IsFIFO32Mode.argtypes = [c_int]
RoBoIO.com_IsFIFO32Mode.restype = c_bool
com_IsFIFO32Mode = RoBoIO.com_IsFIFO32Mode

RoBoIO.com_kbhit.argtypes = [c_int]
RoBoIO.com_kbhit.restype = c_bool
com_kbhit = RoBoIO.com_kbhit

RoBoIO.com_getch.argtypes = [c_int]
RoBoIO.com_getch.restype = c_uint
com_getch = RoBoIO.com_getch

RoBoIO.com1_InUse.argtypes = None
RoBoIO.com1_InUse.restype = c_bool
com1_InUse = RoBoIO.com1_InUse

RoBoIO.com2_InUse.argtypes = None
RoBoIO.com2_InUse.restype = c_bool
com2_InUse = RoBoIO.com2_InUse

RoBoIO.com3_InUse.argtypes = None
RoBoIO.com3_InUse.restype = c_bool
com3_InUse = RoBoIO.com3_InUse

RoBoIO.com4_InUse.argtypes = None
RoBoIO.com4_InUse.restype = c_bool
com4_InUse = RoBoIO.com4_InUse

RoBoIO.com1_Init.argtypes = [c_int]
RoBoIO.com1_Init.restype = c_bool
com1_Init = RoBoIO.com1_Init

RoBoIO.com2_Init.argtypes = [c_int]
RoBoIO.com2_Init.restype = c_bool
com2_Init = RoBoIO.com2_Init

RoBoIO.com3_Init.argtypes = [c_int]
RoBoIO.com3_Init.restype = c_bool
com3_Init = RoBoIO.com3_Init

RoBoIO.com4_Init.argtypes = [c_int]
RoBoIO.com4_Init.restype = c_bool
com4_Init = RoBoIO.com4_Init

RoBoIO.com1_Close.argtypes = None
RoBoIO.com1_Close.restype = None
com1_Close = RoBoIO.com1_Close

RoBoIO.com2_Close.argtypes = None
RoBoIO.com2_Close.restype = None
com2_Close = RoBoIO.com2_Close

RoBoIO.com3_Close.argtypes = None
RoBoIO.com3_Close.restype = None
com3_Close = RoBoIO.com3_Close

RoBoIO.com4_Close.argtypes = None
RoBoIO.com4_Close.restype = None
com4_Close = RoBoIO.com4_Close

RoBoIO.com1_Send.argtypes = [c_void_p, c_int]
RoBoIO.com1_Send.restype = c_bool
#com1_Send = RoBoIO.com1_Send
def com1_Send(buf, bsize):
    ubyte = c_ubyte * bsize
    temp = ubyte()
    for i in range(min(len(buf), bsize)):
        temp[i] = buf[i]
    if not RoBoIO.com1_Send(temp, bsize):
        return False
    return True   

RoBoIO.com2_Send.argtypes = [c_void_p, c_int]
RoBoIO.com2_Send.restype = c_bool
#com2_Send = RoBoIO.com2_Send
def com2_Send(buf, bsize):
    ubyte = c_ubyte * bsize
    temp = ubyte()
    for i in range(min(len(buf), bsize)):
        temp[i] = buf[i]
    if not RoBoIO.com2_Send(temp, bsize):
        return False
    return True    

RoBoIO.com3_Send.argtypes = [c_void_p, c_int]
RoBoIO.com3_Send.restype = c_bool
#com3_Send = RoBoIO.com3_Send
def com3_Send(buf, bsize):
    ubyte = c_ubyte * bsize
    temp = ubyte()
    for i in range(min(len(buf), bsize)):
        temp[i] = buf[i]
    if not RoBoIO.com3_Send(temp, bsize):
        return False
    return True    

RoBoIO.com4_Send.argtypes = [c_void_p, c_int]
RoBoIO.com4_Send.restype = c_bool
#com4_Send = RoBoIO.com4_Send
def com4_Send(buf, bsize):
    ubyte = c_ubyte * bsize
    temp = ubyte()
    for i in range(min(len(buf), bsize)):
        temp[i] = buf[i]
    if not RoBoIO.com4_Send(temp, bsize):
        return False
    return True   

RoBoIO.com1_Write.argtypes = [c_ubyte]
RoBoIO.com1_Write.restype = c_bool
com1_Write = RoBoIO.com1_Write

RoBoIO.com2_Write.argtypes = [c_ubyte]
RoBoIO.com2_Write.restype = c_bool
com2_Write = RoBoIO.com2_Write

RoBoIO.com3_Write.argtypes = [c_ubyte]
RoBoIO.com3_Write.restype = c_bool
com3_Write = RoBoIO.com3_Write

RoBoIO.com4_Write.argtypes = [c_ubyte]
RoBoIO.com4_Write.restype = c_bool
com4_Write = RoBoIO.com4_Write

RoBoIO.com1_Receive.argtypes = [c_void_p, c_int]
RoBoIO.com1_Receive.restype = c_bool
#com1_Receive = RoBoIO.com1_Receive
def com1_Receive(buf, bsize):
    if len(buf)<bsize:
        for i in range(len(buf), bsize):
            buf.append(0)
    ubyte = c_ubyte * bsize
    temp = ubyte()
    if not RoBoIO.com1_Receive(temp, bsize):
        return False
    for i in range(bsize):
        buf[i] = temp[i]
    return True

RoBoIO.com2_Receive.argtypes = [c_void_p, c_int]
RoBoIO.com2_Receive.restype = c_bool
#com2_Receive = RoBoIO.com2_Receive
def com2_Receive(buf, bsize):
    if len(buf)<bsize:
        for i in range(len(buf), bsize):
            buf.append(0)
    ubyte = c_ubyte * bsize
    temp = ubyte()
    if not RoBoIO.com2_Receive(temp, bsize):
        return False
    for i in range(bsize):
        buf[i] = temp[i]
    return True

RoBoIO.com3_Receive.argtypes = [c_void_p, c_int]
RoBoIO.com3_Receive.restype = c_bool
#com3_Receive = RoBoIO.com3_Receive
def com3_Receive(buf, bsize):
    if len(buf)<bsize:
        for i in range(len(buf), bsize):
            buf.append(0)
    ubyte = c_ubyte * bsize
    temp = ubyte()
    if not RoBoIO.com3_Receive(temp, bsize):
        return False
    for i in range(bsize):
        buf[i] = temp[i]
    return True

RoBoIO.com4_Receive.argtypes = [c_void_p, c_int]
RoBoIO.com4_Receive.restype = c_bool
#com4_Receive = RoBoIO.com4_Receive
def com4_Receive(buf, bsize):
    if len(buf)<bsize:
        for i in range(len(buf), bsize):
            buf.append(0)
    ubyte = c_ubyte * bsize
    temp = ubyte()
    if not RoBoIO.com4_Receive(temp, bsize):
        return False
    for i in range(bsize):
        buf[i] = temp[i]
    return True

RoBoIO.com1_Read.argtypes = None
RoBoIO.com1_Read.restype = c_uint
com1_Read = RoBoIO.com1_Read

RoBoIO.com2_Read.argtypes = None
RoBoIO.com2_Read.restype = c_uint
com2_Read = RoBoIO.com2_Read

RoBoIO.com3_Read.argtypes = None
RoBoIO.com3_Read.restype = c_uint
com3_Read = RoBoIO.com3_Read

RoBoIO.com4_Read.argtypes = None
RoBoIO.com4_Read.restype = c_uint
com4_Read = RoBoIO.com4_Read

RoBoIO.com1_ClearWFIFO.argtypes = None
RoBoIO.com1_ClearWFIFO.restype = c_bool
com1_ClearWFIFO = RoBoIO.com1_ClearWFIFO

RoBoIO.com2_ClearWFIFO.argtypes = None
RoBoIO.com2_ClearWFIFO.restype = c_bool
com2_ClearWFIFO = RoBoIO.com2_ClearWFIFO

RoBoIO.com3_ClearWFIFO.argtypes = None
RoBoIO.com3_ClearWFIFO.restype = c_bool
com3_ClearWFIFO = RoBoIO.com3_ClearWFIFO

RoBoIO.com4_ClearWFIFO.argtypes = None
RoBoIO.com4_ClearWFIFO.restype = c_bool
com4_ClearWFIFO = RoBoIO.com4_ClearWFIFO

RoBoIO.com1_FlushWFIFO.argtypes = None
RoBoIO.com1_FlushWFIFO.restype = c_bool
com1_FlushWFIFO = RoBoIO.com1_FlushWFIFO

RoBoIO.com2_FlushWFIFO.argtypes = None
RoBoIO.com2_FlushWFIFO.restype = c_bool
com2_FlushWFIFO = RoBoIO.com2_FlushWFIFO

RoBoIO.com3_FlushWFIFO.argtypes = None
RoBoIO.com3_FlushWFIFO.restype = c_bool
com3_FlushWFIFO = RoBoIO.com3_FlushWFIFO

RoBoIO.com4_FlushWFIFO.argtypes = None
RoBoIO.com4_FlushWFIFO.restype = c_bool
com4_FlushWFIFO = RoBoIO.com4_FlushWFIFO

RoBoIO.com1_ClearRFIFO.argtypes = None
RoBoIO.com1_ClearRFIFO.restype = c_bool
com1_ClearRFIFO = RoBoIO.com1_ClearRFIFO

RoBoIO.com2_ClearRFIFO.argtypes = None
RoBoIO.com2_ClearRFIFO.restype = c_bool
com2_ClearRFIFO = RoBoIO.com2_ClearRFIFO

RoBoIO.com3_ClearRFIFO.argtypes = None
RoBoIO.com3_ClearRFIFO.restype = c_bool
com3_ClearRFIFO = RoBoIO.com3_ClearRFIFO

RoBoIO.com4_ClearRFIFO.argtypes = None
RoBoIO.com4_ClearRFIFO.restype = c_bool
com4_ClearRFIFO = RoBoIO.com4_ClearRFIFO

RoBoIO.com1_QueryRFIFO.argtypes = None
RoBoIO.com1_QueryRFIFO.restype = c_int
com1_QueryRFIFO = RoBoIO.com1_QueryRFIFO

RoBoIO.com2_QueryRFIFO.argtypes = None
RoBoIO.com2_QueryRFIFO.restype = c_int
com2_QueryRFIFO = RoBoIO.com2_QueryRFIFO

RoBoIO.com3_QueryRFIFO.argtypes = None
RoBoIO.com3_QueryRFIFO.restype = c_int
com3_QueryRFIFO = RoBoIO.com3_QueryRFIFO

RoBoIO.com4_QueryRFIFO.argtypes = None
RoBoIO.com4_QueryRFIFO.restype = c_int
com4_QueryRFIFO = RoBoIO.com4_QueryRFIFO

RoBoIO.com1_SetFormat.argtypes = [c_int, c_int, c_int]
RoBoIO.com1_SetFormat.restype = c_bool
com1_SetFormat = RoBoIO.com1_SetFormat

RoBoIO.com2_SetFormat.argtypes = [c_int, c_int, c_int]
RoBoIO.com2_SetFormat.restype = c_bool
com2_SetFormat = RoBoIO.com2_SetFormat

RoBoIO.com3_SetFormat.argtypes = [c_int, c_int, c_int]
RoBoIO.com3_SetFormat.restype = c_bool
com3_SetFormat = RoBoIO.com3_SetFormat

RoBoIO.com4_SetFormat.argtypes = [c_int, c_int, c_int]
RoBoIO.com4_SetFormat.restype = c_bool
com4_SetFormat = RoBoIO.com4_SetFormat

RoBoIO.com1_SetBaud.argtypes = [c_int]
RoBoIO.com1_SetBaud.restype = c_bool
com1_SetBaud = RoBoIO.com1_SetBaud

RoBoIO.com2_SetBaud.argtypes = [c_int]
RoBoIO.com2_SetBaud.restype = c_bool
com2_SetBaud = RoBoIO.com2_SetBaud

RoBoIO.com3_SetBaud.argtypes = [c_int]
RoBoIO.com3_SetBaud.restype = c_bool
com3_SetBaud = RoBoIO.com3_SetBaud

RoBoIO.com4_SetBaud.argtypes = [c_int]
RoBoIO.com4_SetBaud.restype = c_bool
com4_SetBaud = RoBoIO.com4_SetBaud

RoBoIO.com1_ServoTRX.argtypes = [c_void_p, c_int, c_void_p, c_int]
RoBoIO.com1_ServoTRX.restype = c_bool
#com1_ServoTRX = RoBoIO.com1_ServoTRX
def com1_ServoTRX(cmd, csize, buf, bsize):
    if len(buf)<bsize:
        for i in range(len(buf), bsize):
            buf.append(0)
    ubyte2 = c_type * csize
    temp = ubyte2()	
    ubyte = c_ubyte * bsize
    temp2 = ubyte()
    for i in range(min(len(cmd), csize)):
        temp[i] = cmd[i]
    if not RoBoIO.com1_ServoTRX(temp, csize, temp2, bsize):
        return False
    for i in range(bsize):
        buf[i] = temp2[i]
    return True 

RoBoIO.com2_ServoTRX.argtypes = [c_void_p, c_int, c_void_p, c_int]
RoBoIO.com2_ServoTRX.restype = c_bool
#com2_ServoTRX = RoBoIO.com2_ServoTRX
def com2_ServoTRX(cmd, csize, buf, bsize):
    if len(buf)<bsize:
        for i in range(len(buf), bsize):
            buf.append(0)
    ubyte2 = c_type * csize
    temp = ubyte2()	
    ubyte = c_ubyte * bsize
    temp2 = ubyte()
    for i in range(min(len(cmd), csize)):
        temp[i] = cmd[i]
    if not RoBoIO.com2_ServoTRX(temp, csize, temp2, bsize):
        return False
    for i in range(bsize):
        buf[i] = temp2[i]
    return True 

RoBoIO.com3_ServoTRX.argtypes = [c_void_p, c_int, c_void_p, c_int]
RoBoIO.com3_ServoTRX.restype = c_bool
#com3_ServoTRX = RoBoIO.com3_ServoTRX
def com3_ServoTRX(cmd, csize, buf, bsize):
    if len(buf)<bsize:
        for i in range(len(buf), bsize):
            buf.append(0)
    ubyte2 = c_type * csize
    temp = ubyte2()	
    ubyte = c_ubyte * bsize
    temp2 = ubyte()
    for i in range(min(len(cmd), csize)):
        temp[i] = cmd[i]
    if not RoBoIO.com3_ServoTRX(temp, csize, temp2, bsize):
        return False
    for i in range(bsize):
        buf[i] = temp2[i]
    return True  

RoBoIO.com4_ServoTRX.argtypes = [c_void_p, c_int, c_void_p, c_int]
RoBoIO.com4_ServoTRX.restype = c_bool
#com4_ServoTRX = RoBoIO.com4_ServoTRX
def com4_ServoTRX(cmd, csize, buf, bsize):
    if len(buf)<bsize:
        for i in range(len(buf), bsize):
            buf.append(0)
    ubyte2 = c_type * csize
    temp = ubyte2()	
    ubyte = c_ubyte * bsize
    temp2 = ubyte()
    for i in range(min(len(cmd), csize)):
        temp[i] = cmd[i]
    if not RoBoIO.com4_ServoTRX(temp, csize, temp2, bsize):
        return False
    for i in range(bsize):
        buf[i] = temp2[i]
    return True 

RoBoIO.com1_EnableTurboMode.argtypes = None
RoBoIO.com1_EnableTurboMode.restype = None
com1_EnableTurboMode = RoBoIO.com1_EnableTurboMode

RoBoIO.com2_EnableTurboMode.argtypes = None
RoBoIO.com2_EnableTurboMode.restype = None
com2_EnableTurboMode = RoBoIO.com2_EnableTurboMode

RoBoIO.com3_EnableTurboMode.argtypes = None
RoBoIO.com3_EnableTurboMode.restype = None
com3_EnableTurboMode = RoBoIO.com3_EnableTurboMode

RoBoIO.com4_EnableTurboMode.argtypes = None
RoBoIO.com4_EnableTurboMode.restype = None
com4_EnableTurboMode = RoBoIO.com4_EnableTurboMode

RoBoIO.com1_DisableTurboMode.argtypes = None
RoBoIO.com1_DisableTurboMode.restype = None
com1_DisableTurboMode = RoBoIO.com1_DisableTurboMode

RoBoIO.com2_DisableTurboMode.argtypes = None
RoBoIO.com2_DisableTurboMode.restype = None
com2_DisableTurboMode = RoBoIO.com2_DisableTurboMode

RoBoIO.com3_DisableTurboMode.argtypes = None
RoBoIO.com3_DisableTurboMode.restype = None
com3_DisableTurboMode = RoBoIO.com3_DisableTurboMode

RoBoIO.com4_DisableTurboMode.argtypes = None
RoBoIO.com4_DisableTurboMode.restype = None
com4_DisableTurboMode = RoBoIO.com4_DisableTurboMode

RoBoIO.com1_IsTurboMode.argtypes = None
RoBoIO.com1_IsTurboMode.restype = c_bool
com1_IsTurboMode = RoBoIO.com1_IsTurboMode

RoBoIO.com2_IsTurboMode.argtypes = None
RoBoIO.com2_IsTurboMode.restype = c_bool
com2_IsTurboMode = RoBoIO.com2_IsTurboMode

RoBoIO.com3_IsTurboMode.argtypes = None
RoBoIO.com3_IsTurboMode.restype = c_bool
com3_IsTurboMode = RoBoIO.com3_IsTurboMode

RoBoIO.com4_IsTurboMode.argtypes = None
RoBoIO.com4_IsTurboMode.restype = c_bool
com4_IsTurboMode = RoBoIO.com4_IsTurboMode

#io.h
RoBoIO.io_InUse.argtypes = None
RoBoIO.io_InUse.restype = c_bool
io_InUse = RoBoIO.io_InUse

RoBoIO.io_Init.argtypes = None
RoBoIO.io_Init.restype = c_int
io_Init = RoBoIO.io_Init

RoBoIO.io_init.argtypes = None
RoBoIO.io_init.restype = c_bool
io_init = RoBoIO.io_init

ERROR_IOINITFAIL = (ERR_NOERROR + 100)
ERROR_IOSECTIONFULL = (ERR_NOERROR + 101)
ERROR_CPUUNSUPPORTED = (ERR_NOERROR + 102)
RoBoIO.io_Close.argtypes = [c_int]
RoBoIO.io_Close.restype = None
io_Close = RoBoIO.io_Close

RoBoIO.io_close.argtypes = None
RoBoIO.io_close.restype = None
io_close = RoBoIO.io_close

RoBoIO.io_outpdw.argtypes = [c_ushort, c_uint]
RoBoIO.io_outpdw.restype = None
io_outpdw = RoBoIO.io_outpdw

RoBoIO.io_inpdw.argtypes = [c_ushort]
RoBoIO.io_inpdw.restype = c_uint
io_inpdw = RoBoIO.io_inpdw

RoBoIO.io_outpw.argtypes = [c_ushort, c_ushort]
RoBoIO.io_outpw.restype = None
io_outpw = RoBoIO.io_outpw

RoBoIO.io_inpw.argtypes = [c_ushort]
RoBoIO.io_inpw.restype = c_ushort
io_inpw = RoBoIO.io_inpw

RoBoIO.io_outpb.argtypes = [c_ushort, c_ubyte]
RoBoIO.io_outpb.restype = None
io_outpb = RoBoIO.io_outpb

RoBoIO.io_inpb.argtypes = [c_ushort]
RoBoIO.io_inpb.restype = c_ubyte
io_inpb = RoBoIO.io_inpb

RoBoIO.io_SetISASpeed.argtypes = [c_int]
RoBoIO.io_SetISASpeed.restype = None
io_SetISASpeed = RoBoIO.io_SetISASpeed

ISAMODE_NORMAL = (0)
ISAMODE_HIGHSPEED = (1)
RoBoIO.io_CpuID.argtypes = None
RoBoIO.io_CpuID.restype = c_int
io_CpuID = RoBoIO.io_CpuID

CPU_UNSUPPORTED = (0)
CPU_VORTEX86SX = (10)
CPU_VORTEX86DX_1 = (21)
CPU_VORTEX86DX_2 = (22)
CPU_VORTEX86DX_3 = (23)
CPU_VORTEX86DX_UNKNOWN = (24)
CPU_VORTEX86MX = (30)
CPU_VORTEX86MX_PLUS = (33)
RoBoIO.io_GetDRAMCLK.argtypes = None
RoBoIO.io_GetDRAMCLK.restype = c_uint
io_GetDRAMCLK = RoBoIO.io_GetDRAMCLK

RoBoIO.io_GetCPUCLK.argtypes = None
RoBoIO.io_GetCPUCLK.restype = c_uint
io_GetCPUCLK = RoBoIO.io_GetCPUCLK

RoBoIO.io_EnableIRQ.argtypes = None
RoBoIO.io_EnableIRQ.restype = None
io_EnableIRQ = RoBoIO.io_EnableIRQ

RoBoIO.io_DisableIRQ.argtypes = None
RoBoIO.io_DisableIRQ.restype = None
io_DisableIRQ = RoBoIO.io_DisableIRQ

RoBoIO.io_outpcidw.argtypes = [c_uint, c_uint]
RoBoIO.io_outpcidw.restype = None
io_outpcidw = RoBoIO.io_outpcidw

RoBoIO.io_inpcidw.argtypes = [c_uint]
RoBoIO.io_inpcidw.restype = c_uint
io_inpcidw = RoBoIO.io_inpcidw

RoBoIO.io_outpciw.argtypes = [c_uint, c_ushort]
RoBoIO.io_outpciw.restype = None
io_outpciw = RoBoIO.io_outpciw

RoBoIO.io_inpciw.argtypes = [c_uint]
RoBoIO.io_inpciw.restype = c_ushort
io_inpciw = RoBoIO.io_inpciw

RoBoIO.io_outpcib.argtypes = [c_uint, c_ubyte]
RoBoIO.io_outpcib.restype = None
io_outpcib = RoBoIO.io_outpcib

RoBoIO.io_inpcib.argtypes = [c_uint]
RoBoIO.io_inpcib.restype = c_ubyte
io_inpcib = RoBoIO.io_inpcib

RoBoIO.read_sb_regb.argtypes = [c_ubyte]
RoBoIO.read_sb_regb.restype = c_ubyte
read_sb_regb = RoBoIO.read_sb_regb

RoBoIO.read_sb_regw.argtypes = [c_ubyte]
RoBoIO.read_sb_regw.restype = c_ushort
read_sb_regw = RoBoIO.read_sb_regw

RoBoIO.read_sb_reg.argtypes = [c_ubyte]
RoBoIO.read_sb_reg.restype = c_uint
read_sb_reg = RoBoIO.read_sb_reg

RoBoIO.write_sb_regb.argtypes = [c_ubyte, c_ubyte]
RoBoIO.write_sb_regb.restype = None
write_sb_regb = RoBoIO.write_sb_regb

RoBoIO.write_sb_regw.argtypes = [c_ubyte, c_ushort]
RoBoIO.write_sb_regw.restype = None
write_sb_regw = RoBoIO.write_sb_regw

RoBoIO.write_sb_reg.argtypes = [c_ubyte, c_uint]
RoBoIO.write_sb_reg.restype = None
write_sb_reg = RoBoIO.write_sb_reg

RoBoIO.read_nb_regb.argtypes = [c_ubyte]
RoBoIO.read_nb_regb.restype = c_ubyte
read_nb_regb = RoBoIO.read_nb_regb

RoBoIO.read_nb_regw.argtypes = [c_ubyte]
RoBoIO.read_nb_regw.restype = c_ushort
read_nb_regw = RoBoIO.read_nb_regw

RoBoIO.read_nb_reg.argtypes = [c_ubyte]
RoBoIO.read_nb_reg.restype = c_uint
read_nb_reg = RoBoIO.read_nb_reg

RoBoIO.write_nb_regb.argtypes = [c_ubyte, c_ubyte]
RoBoIO.write_nb_regb.restype = None
write_nb_regb = RoBoIO.write_nb_regb

RoBoIO.write_nb_regw.argtypes = [c_ubyte, c_ushort]
RoBoIO.write_nb_regw.restype = None
write_nb_regw = RoBoIO.write_nb_regw

RoBoIO.write_nb_reg.argtypes = [c_ubyte, c_uint]
RoBoIO.write_nb_reg.restype = None
write_nb_reg = RoBoIO.write_nb_reg

#rcservo.h
RoBoIO.rcservo_InUse.argtypes = None
RoBoIO.rcservo_InUse.restype = c_bool
rcservo_InUse = RoBoIO.rcservo_InUse

RoBoIO.rcservo_Init.argtypes = [c_uint]
RoBoIO.rcservo_Init.restype = c_bool
rcservo_Init = RoBoIO.rcservo_Init

RCSERVO_USENOPIN = (0)
RCSERVO_USEPINS1 = (1)
RCSERVO_USEPINS2 = (1<<1)
RCSERVO_USEPINS3 = (1<<2)
RCSERVO_USEPINS4 = (1<<3)
RCSERVO_USEPINS5 = (1<<4)
RCSERVO_USEPINS6 = (1<<5)
RCSERVO_USEPINS7 = (1<<6)
RCSERVO_USEPINS8 = (1<<7)
RCSERVO_USEPINS9 = (1<<8)
RCSERVO_USEPINS10 = (1<<9)
RCSERVO_USEPINS11 = (1<<10)
RCSERVO_USEPINS12 = (1<<11)
RCSERVO_USEPINS13 = (1<<12)
RCSERVO_USEPINS14 = (1<<13)
RCSERVO_USEPINS15 = (1<<14)
RCSERVO_USEPINS16 = (1<<15)
RCSERVO_USEPINS17 = (1<<16)
RCSERVO_USEPINS18 = (1<<17)
RCSERVO_USEPINS19 = (1<<18)
RCSERVO_USEPINS20 = (1<<19)
RCSERVO_USEPINS21 = (1<<20)
RCSERVO_USEPINS22 = (1<<21)
RCSERVO_USEPINS23 = (1<<22)
RCSERVO_USEPINS24 = (1<<23)
RCSERVO_USEPINS25 = (1<<24)
RCSERVO_USEPINS26 = (1<<25)
RCSERVO_USEPINS27 = (1<<26)
RCSERVO_USEPINS28 = (1<<27)
RCSERVO_USEPINS29 = (1<<28)
RCSERVO_USEPINS30 = (1<<29)
RCSERVO_USEPINS31 = (1<<30)
RCSERVO_USEPINS32 = (1<<31)
ERROR_RCSERVO_INUSE = (ERR_NOERROR + 400)
ERROR_RCSERVO_PWMINUSE = (ERR_NOERROR + 401)
RoBoIO.rcservo_Close.argtypes = None
RoBoIO.rcservo_Close.restype = None
rcservo_Close = RoBoIO.rcservo_Close

RoBoIO.rcservo_SetServo.argtypes = [c_int, c_uint]
RoBoIO.rcservo_SetServo.restype = c_bool
rcservo_SetServo = RoBoIO.rcservo_SetServo

RCSERVO_PINS1 = (0)
RCSERVO_PINS2 = (1)
RCSERVO_PINS3 = (2)
RCSERVO_PINS4 = (3)
RCSERVO_PINS5 = (4)
RCSERVO_PINS6 = (5)
RCSERVO_PINS7 = (6)
RCSERVO_PINS8 = (7)
RCSERVO_PINS9 = (8)
RCSERVO_PINS10 = (9)
RCSERVO_PINS11 = (10)
RCSERVO_PINS12 = (11)
RCSERVO_PINS13 = (12)
RCSERVO_PINS14 = (13)
RCSERVO_PINS15 = (14)
RCSERVO_PINS16 = (15)
RCSERVO_PINS17 = (16)
RCSERVO_PINS18 = (17)
RCSERVO_PINS19 = (18)
RCSERVO_PINS20 = (19)
RCSERVO_PINS21 = (20)
RCSERVO_PINS22 = (21)
RCSERVO_PINS23 = (22)
RCSERVO_PINS24 = (23)
RCSERVO_PINS25 = (24)
RCSERVO_PINS26 = (25)
RCSERVO_PINS27 = (26)
RCSERVO_PINS28 = (27)
RCSERVO_PINS29 = (28)
RCSERVO_PINS30 = (29)
RCSERVO_PINS31 = (30)
RCSERVO_PINS32 = (31)
RoBoIO.rcservo_SetServos.argtypes = [c_uint, c_uint]
RoBoIO.rcservo_SetServos.restype = c_bool
rcservo_SetServos = RoBoIO.rcservo_SetServos

RCSERVO_SERVO_DEFAULT = (0x00)
RCSERVO_SERVO_DEFAULT_NOFB = (0x01)
RCSERVO_KONDO_KRS786 = (0x11)
RCSERVO_KONDO_KRS788 = (0x12)
RCSERVO_KONDO_KRS78X = (0x13)
RCSERVO_KONDO_KRS4014 = (0x14)
RCSERVO_KONDO_KRS4024 = (0x15)
RCSERVO_HITEC_HSR8498 = (0x22)
RCSERVO_FUTABA_S3003 = (0x31)
RCSERVO_SHAYYE_SYS214050 = (0x41)
RCSERVO_TOWERPRO_MG995 = (0x51)
RCSERVO_TOWERPRO_MG996 = (0x52)
RCSERVO_DMP_RS0263 = (0x61)
RCSERVO_DMP_RS1270 = (0x62)
RCSERVO_GWS_S777 = (0x71)
RCSERVO_GWS_S03T = (0x72)
RCSERVO_GWS_MICRO = (0x73)
ERROR_RCSERVO_UNKNOWNSERVO = (ERR_NOERROR + 461)
ERROR_RCSERVO_WRONGCHANNEL = (ERR_NOERROR + 462)
RoBoIO.rcservo_SetServoType.argtypes = [c_int, c_uint, c_uint]
RoBoIO.rcservo_SetServoType.restype = c_bool
rcservo_SetServoType = RoBoIO.rcservo_SetServoType

RCSERVO_SV_FEEDBACK = (1)
RCSERVO_SV_NOFEEDBACK = (2)
RCSERVO_FB_SAFEMODE = (0)
RCSERVO_FB_FASTMODE = (1)
RCSERVO_FB_DENOISE = (1<<1)
RoBoIO.rcservo_SetServoParams1.argtypes = [c_int, c_uint, c_uint, c_uint]
RoBoIO.rcservo_SetServoParams1.restype = c_bool
rcservo_SetServoParams1 = RoBoIO.rcservo_SetServoParams1

RoBoIO.rcservo_SetServoParams2.argtypes = [c_int, c_uint, c_uint]
RoBoIO.rcservo_SetServoParams2.restype = c_bool
rcservo_SetServoParams2 = RoBoIO.rcservo_SetServoParams2

ERROR_RCSERVO_INVALIDPARAMS = (ERR_NOERROR + 463)
RoBoIO.rcservo_SetReadFBParams1.argtypes = [c_int, c_uint, c_uint, c_uint]
RoBoIO.rcservo_SetReadFBParams1.restype = c_bool
rcservo_SetReadFBParams1 = RoBoIO.rcservo_SetReadFBParams1

RoBoIO.rcservo_SetReadFBParams2.argtypes = [c_int, c_uint, c_long]
RoBoIO.rcservo_SetReadFBParams2.restype = c_bool
rcservo_SetReadFBParams2 = RoBoIO.rcservo_SetReadFBParams2

RoBoIO.rcservo_SetReadFBParams3.argtypes = [c_int, c_int, c_int]
RoBoIO.rcservo_SetReadFBParams3.restype = c_bool
rcservo_SetReadFBParams3 = RoBoIO.rcservo_SetReadFBParams3

RoBoIO.rcservo_SetCmdPulse.argtypes = [c_int, c_int, c_uint]
RoBoIO.rcservo_SetCmdPulse.restype = c_bool
rcservo_SetCmdPulse = RoBoIO.rcservo_SetCmdPulse

RoBoIO.rcservo_SetPlayModeCMD.argtypes = [c_int, c_int]
RoBoIO.rcservo_SetPlayModeCMD.restype = c_bool
rcservo_SetPlayModeCMD = RoBoIO.rcservo_SetPlayModeCMD

RCSERVO_CMD_POWEROFF = (0)
RCSERVO_CMD1 = (1)
RCSERVO_CMD2 = (2)
RCSERVO_CMD3 = (3)
RCSERVO_CMD4 = (4)
RCSERVO_CMD5 = (5)
RCSERVO_CMD6 = (6)
RCSERVO_CMD7 = (7)
RoBoIO.rcservo_EnterCaptureMode.argtypes = None
RoBoIO.rcservo_EnterCaptureMode.restype = None
rcservo_EnterCaptureMode = RoBoIO.rcservo_EnterCaptureMode

RoBoIO.rcservo_ReadPosition.argtypes = [c_int, c_int]
RoBoIO.rcservo_ReadPosition.restype = c_uint
rcservo_ReadPosition = RoBoIO.rcservo_ReadPosition

RoBoIO.rcservo_ReadPositionDN.argtypes = [c_int, c_int]
RoBoIO.rcservo_ReadPositionDN.restype = c_uint
rcservo_ReadPositionDN = RoBoIO.rcservo_ReadPositionDN

RoBoIO.rcservo_ReadPositions.argtypes = [c_uint, c_int, c_void_p]
RoBoIO.rcservo_ReadPositions.restype = None
#rcservo_ReadPositions = RoBoIO.rcservo_ReadPositions
def rcservo_ReadPositions(channels, cmd, width):
    if len(width)<32:
        for i in range(len(width), 32):
            width.append(0)
    ulong = c_ulong * 32
    temp = ulong()
    RoBoIO.rcservo_ReadPositions(channels, cmd, temp)
    for i in range(32):
        width[i] = temp[i]

RoBoIO.rcservo_ReadPositionsDN.argtypes = [c_uint, c_int, c_void_p]
RoBoIO.rcservo_ReadPositionsDN.restype = None
#rcservo_ReadPositionsDN = RoBoIO.rcservo_ReadPositionsDN
def rcservo_ReadPositionsDN(channels, cmd, width):
    if len(width)<32:
        for i in range(len(width), 32):
            width.append(0)
    ulong = c_ulong * 32
    temp = ulong()
    RoBoIO.rcservo_ReadPositionsDN(channels, cmd, temp)
    for i in range(32):
        width[i] = temp[i]

RoBoIO.rcservo_CapOne.argtypes = [c_int]
RoBoIO.rcservo_CapOne.restype = c_uint
rcservo_CapOne = RoBoIO.rcservo_CapOne

RoBoIO.rcservo_CapAll.argtypes = [c_void_p]
RoBoIO.rcservo_CapAll.restype = c_bool
#rcservo_CapAll = RoBoIO.rcservo_CapAll
def rcservo_CapAll(width):
    if len(width)<32:
        for i in range(len(width), 32):
            width.append(0)
    ulong = c_ulong * 32
    temp = ulong()
    if not RoBoIO.rcservo_CapAll(temp):
        return False
    for i in range(32):
        width[i] = temp[i]
    return True

RoBoIO.rcservo_EnableMPOS.argtypes = None
RoBoIO.rcservo_EnableMPOS.restype = None
rcservo_EnableMPOS = RoBoIO.rcservo_EnableMPOS

RoBoIO.rcservo_DisableMPOS.argtypes = None
RoBoIO.rcservo_DisableMPOS.restype = None
rcservo_DisableMPOS = RoBoIO.rcservo_DisableMPOS

RoBoIO.rcservo_SendCMD.argtypes = [c_int, c_int]
RoBoIO.rcservo_SendCMD.restype = None
rcservo_SendCMD = RoBoIO.rcservo_SendCMD

RoBoIO.rcservo_EnterPlayMode.argtypes = None
RoBoIO.rcservo_EnterPlayMode.restype = None
rcservo_EnterPlayMode = RoBoIO.rcservo_EnterPlayMode

RoBoIO.rcservo_EnterPlayMode_NOFB.argtypes = [c_void_p]
RoBoIO.rcservo_EnterPlayMode_NOFB.restype = None
#rcservo_EnterPlayMode_NOFB = RoBoIO.rcservo_EnterPlayMode_NOFB
def rcservo_EnterPlayMode_NOFB(width):
    ulong = c_ulong * 32
    temp = ulong()
    for i in range(32):
        if i >= len(width):
            temp[i] = 0
        else:
            temp[i] = width[i]
    RoBoIO.rcservo_EnterPlayMode_NOFB(temp)

RoBoIO.rcservo_EnterPlayMode_HOME.argtypes = [c_void_p]
RoBoIO.rcservo_EnterPlayMode_HOME.restype = None
#rcservo_EnterPlayMode_HOME = RoBoIO.rcservo_EnterPlayMode_HOME
def rcservo_EnterPlayMode_HOME(width):
    ulong = c_ulong * 32
    temp = ulong()
    for i in range(32):
        if i >= len(width):
            temp[i] = 0
        else:
            temp[i] = width[i]
    RoBoIO.rcservo_EnterPlayMode_HOME(temp)

RoBoIO.rcservo_SetFPS.argtypes = [c_int]
RoBoIO.rcservo_SetFPS.restype = None
rcservo_SetFPS = RoBoIO.rcservo_SetFPS

RoBoIO.rcservo_SetAction.argtypes = [c_void_p, c_uint]
RoBoIO.rcservo_SetAction.restype = None
#rcservo_SetAction = RoBoIO.rcservo_SetAction
def rcservo_SetAction(width, playtime):
    ulong = c_ulong * 32
    temp = ulong()
    for i in range(32):
        if i >= len(width):
            temp[i] = 0
        else:
            temp[i] = width[i]
    RoBoIO.rcservo_SetAction(temp, playtime)

RoBoIO.rcservo_PlayAction.argtypes = None
RoBoIO.rcservo_PlayAction.restype = c_int
rcservo_PlayAction = RoBoIO.rcservo_PlayAction

RoBoIO.rcservo_PlayActionMix.argtypes = [c_void_p]
RoBoIO.rcservo_PlayActionMix.restype = c_int
#rcservo_PlayActionMix = RoBoIO.rcservo_PlayActionMix
def rcservo_PlayActionMix(mixwidth):
    ulong = c_ulong * 32
    temp = ulong()
    for i in range(32):
        if i >= len(mixwidth):
            temp[i] = 0
        else:
            temp[i] = mixwidth[i]
    return RoBoIO.rcservo_PlayActionMix(temp)

RCSERVO_PLAYEND = (0)
RCSERVO_PLAYING = (1)
RCSERVO_PAUSED = (2)
RCSERVO_MIXWIDTH_POWEROFF = (0x7fffff00)
RCSERVO_MIXWIDTH_CMD1 = (0x7fffff01)
RCSERVO_MIXWIDTH_CMD2 = (0x7fffff02)
RCSERVO_MIXWIDTH_CMD3 = (0x7fffff03)
RCSERVO_MIXWIDTH_CMD4 = (0x7fffff04)
RCSERVO_MIXWIDTH_CMD5 = (0x7fffff05)
RCSERVO_MIXWIDTH_CMD6 = (0x7fffff06)
RCSERVO_MIXWIDTH_CMD7 = (0x7fffff07)
RoBoIO.rcservo_PauseAction.argtypes = None
RoBoIO.rcservo_PauseAction.restype = None
rcservo_PauseAction = RoBoIO.rcservo_PauseAction

RoBoIO.rcservo_ReleaseAction.argtypes = None
RoBoIO.rcservo_ReleaseAction.restype = None
rcservo_ReleaseAction = RoBoIO.rcservo_ReleaseAction

RoBoIO.rcservo_StopAction.argtypes = None
RoBoIO.rcservo_StopAction.restype = None
rcservo_StopAction = RoBoIO.rcservo_StopAction

RoBoIO.rcservo_GetAction.argtypes = [c_void_p]
RoBoIO.rcservo_GetAction.restype = None
#rcservo_GetAction = RoBoIO.rcservo_GetAction
def rcservo_GetAction(width):
    if len(width)<32:
        for i in range(len(width), 32):
            width.append(0)
    ulong = c_ulong * 32
    temp = ulong()
    RoBoIO.rcservo_GetAction(temp)
    for i in range(32):
        width[i] = temp[i]

RoBoIO.rcservo_MoveTo.argtypes = [c_void_p, c_uint]
RoBoIO.rcservo_MoveTo.restype = None
#rcservo_MoveTo = RoBoIO.rcservo_MoveTo
def rcservo_MoveTo(width, playtime):
    ulong = c_ulong * 32
    temp = ulong()
    for i in range(32):
        if i >= len(width):
            temp[i] = 0
        else:
            temp[i] = width[i]
    RoBoIO.rcservo_MoveTo(temp, playtime)

RoBoIO.rcservo_MoveOne.argtypes = [c_int, c_uint, c_uint]
RoBoIO.rcservo_MoveOne.restype = None
rcservo_MoveOne = RoBoIO.rcservo_MoveOne

RoBoIO.rcservo_EnterPWMMode.argtypes = None
RoBoIO.rcservo_EnterPWMMode.restype = None
rcservo_EnterPWMMode = RoBoIO.rcservo_EnterPWMMode

RoBoIO.rcservo_SendPWM.argtypes = [c_int, c_uint, c_uint, c_uint]
RoBoIO.rcservo_SendPWM.restype = c_bool
rcservo_SendPWM = RoBoIO.rcservo_SendPWM

RoBoIO.rcservo_SendCPWM.argtypes = [c_int, c_uint, c_uint]
RoBoIO.rcservo_SendCPWM.restype = c_bool
rcservo_SendCPWM = RoBoIO.rcservo_SendCPWM

ERROR_RCSERVO_PWMFAIL = (ERR_NOERROR + 430)
RoBoIO.rcservo_StopPWM.argtypes = [c_int]
RoBoIO.rcservo_StopPWM.restype = None
rcservo_StopPWM = RoBoIO.rcservo_StopPWM

RoBoIO.rcservo_CheckPWM.argtypes = [c_int]
RoBoIO.rcservo_CheckPWM.restype = c_uint
rcservo_CheckPWM = RoBoIO.rcservo_CheckPWM

RoBoIO.rcservo_OutPin.argtypes = [c_int, c_int]
RoBoIO.rcservo_OutPin.restype = None
rcservo_OutPin = RoBoIO.rcservo_OutPin

RoBoIO.rcservo_InPin.argtypes = [c_int]
RoBoIO.rcservo_InPin.restype = c_int
rcservo_InPin = RoBoIO.rcservo_InPin

RoBoIO.rcservo_OutPort.argtypes = [c_uint, c_uint]
RoBoIO.rcservo_OutPort.restype = None
rcservo_OutPort = RoBoIO.rcservo_OutPort

RoBoIO.rcservo_InPort.argtypes = [c_uint]
RoBoIO.rcservo_InPort.restype = c_uint
rcservo_InPort = RoBoIO.rcservo_InPort

RCSERVO_USENOCHANNEL = (0)
RCSERVO_USECHANNEL0 = (1)
RCSERVO_USECHANNEL1 = (1<<1)
RCSERVO_USECHANNEL2 = (1<<2)
RCSERVO_USECHANNEL3 = (1<<3)
RCSERVO_USECHANNEL4 = (1<<4)
RCSERVO_USECHANNEL5 = (1<<5)
RCSERVO_USECHANNEL6 = (1<<6)
RCSERVO_USECHANNEL7 = (1<<7)
RCSERVO_USECHANNEL8 = (1<<8)
RCSERVO_USECHANNEL9 = (1<<9)
RCSERVO_USECHANNEL10 = (1<<10)
RCSERVO_USECHANNEL11 = (1<<11)
RCSERVO_USECHANNEL12 = (1<<12)
RCSERVO_USECHANNEL13 = (1<<13)
RCSERVO_USECHANNEL14 = (1<<14)
RCSERVO_USECHANNEL15 = (1<<15)
RCSERVO_USECHANNEL16 = (1<<16)
RCSERVO_USECHANNEL17 = (1<<17)
RCSERVO_USECHANNEL18 = (1<<18)
RCSERVO_USECHANNEL19 = (1<<19)
RCSERVO_USECHANNEL20 = (1<<20)
RCSERVO_USECHANNEL21 = (1<<21)
RCSERVO_USECHANNEL22 = (1<<22)
RCSERVO_USECHANNEL23 = (1<<23)
RCSERVO_USECHANNEL24 = (1<<24)
RCSERVO_USECHANNEL25 = (1<<25)
RCSERVO_USECHANNEL26 = (1<<26)
RCSERVO_USECHANNEL27 = (1<<27)
RCSERVO_USECHANNEL28 = (1<<28)
RCSERVO_USECHANNEL29 = (1<<29)
RCSERVO_USECHANNEL30 = (1<<30)
RCSERVO_USECHANNEL31 = (1<<31)
RoBoIO.rcservo_Initialize.argtypes = [c_uint]
RoBoIO.rcservo_Initialize.restype = c_bool
rcservo_Initialize = RoBoIO.rcservo_Initialize

RoBoIO.rcservo_MoveToMix.argtypes = [c_void_p, c_uint, c_void_p]
RoBoIO.rcservo_MoveToMix.restype = None
#rcservo_MoveToMix = RoBoIO.rcservo_MoveToMix
def rcservo_MoveToMix(width, playtime, mixwidth):
    ulong = c_ulong * 32
    temp = ulong()
    temp2 = ulong()
    for i in range(32):
        if i >= len(width):
            temp[i] = 0
        else:
            temp[i] = width[i]
    for i in range(32):
        if i >= len(mixwidth):
            temp2[i] = 0
        else:
            temp2[i] = mixwidth[i]
    RoBoIO.rcservo_MoveTo(temp, playtime, temp2)

RoBoIO.rcservo_SendPWMPulses.argtypes = [c_int, c_uint, c_uint, c_uint]
RoBoIO.rcservo_SendPWMPulses.restype = c_bool
rcservo_SendPWMPulses = RoBoIO.rcservo_SendPWMPulses

RoBoIO.rcservo_IsPWMCompleted.argtypes = [c_int]
RoBoIO.rcservo_IsPWMCompleted.restype = c_bool
rcservo_IsPWMCompleted = RoBoIO.rcservo_IsPWMCompleted

RoBoIO.rcservo_Outp.argtypes = [c_int, c_int]
RoBoIO.rcservo_Outp.restype = None
rcservo_Outp = RoBoIO.rcservo_Outp

RoBoIO.rcservo_Inp.argtypes = [c_int]
RoBoIO.rcservo_Inp.restype = c_int
rcservo_Inp = RoBoIO.rcservo_Inp

RoBoIO.rcservo_Outps.argtypes = [c_uint, c_uint]
RoBoIO.rcservo_Outps.restype = None
rcservo_Outps = RoBoIO.rcservo_Outps

RoBoIO.rcservo_Inps.argtypes = [c_uint]
RoBoIO.rcservo_Inps.restype = c_uint
rcservo_Inps = RoBoIO.rcservo_Inps

#i2c.h
RoBoIO.i2c_InUse.argtypes = None
RoBoIO.i2c_InUse.restype = c_bool
i2c_InUse = RoBoIO.i2c_InUse

RoBoIO.i2c_Init2.argtypes = [c_uint, c_uint, c_int, c_int]
RoBoIO.i2c_Init2.restype = c_bool
i2c_Init2 = RoBoIO.i2c_Init2

I2C_USEMODULE0 = (1<<0)
I2C_USEMODULE1 = (1<<1)
ERROR_I2C_INUSE = (ERR_NOERROR + 600)
ERROR_I2C_INITFAIL = (ERR_NOERROR + 602)
RoBoIO.i2c_Close.argtypes = None
RoBoIO.i2c_Close.restype = None
i2c_Close = RoBoIO.i2c_Close

RoBoIO.i2c_InitSW2.argtypes = [c_uint, c_int, c_uint, c_int, c_uint]
RoBoIO.i2c_InitSW2.restype = c_bool
i2c_InitSW2 = RoBoIO.i2c_InitSW2

I2CSW_NORMAL = (0x10)
I2CSW_LEGO = (0x20)
RoBoIO.i2c_CloseSW.argtypes = None
RoBoIO.i2c_CloseSW.restype = None
i2c_CloseSW = RoBoIO.i2c_CloseSW

RoBoIO.i2c_SetSpeed.argtypes = [c_int, c_int, c_uint]
RoBoIO.i2c_SetSpeed.restype = c_uint
i2c_SetSpeed = RoBoIO.i2c_SetSpeed

I2CMODE_HIGHSPEED = (2)
I2CMODE_AUTO = (3)
ERROR_I2CWRONGUSAGE = (ERR_NOERROR + 630)
RoBoIO.i2cmaster_Start.argtypes = [c_int, c_ubyte, c_ubyte]
RoBoIO.i2cmaster_Start.restype = c_bool
i2cmaster_Start = RoBoIO.i2cmaster_Start

ERROR_I2CARLOSS = (ERR_NOERROR + 621)
ERROR_I2CACKERR = (ERR_NOERROR + 622)
RoBoIO.i2cmaster_Write.argtypes = [c_int, c_ubyte]
RoBoIO.i2cmaster_Write.restype = c_bool
i2cmaster_Write = RoBoIO.i2cmaster_Write

RoBoIO.i2cmaster_WriteLast.argtypes = [c_int, c_ubyte]
RoBoIO.i2cmaster_WriteLast.restype = c_bool
i2cmaster_WriteLast = RoBoIO.i2cmaster_WriteLast

RoBoIO.i2cmaster_Read1.argtypes = [c_int, c_bool]
RoBoIO.i2cmaster_Read1.restype = c_uint
i2cmaster_Read1 = RoBoIO.i2cmaster_Read1

RoBoIO.i2cmaster_ReadLast.argtypes = [c_int]
RoBoIO.i2cmaster_ReadLast.restype = c_uint
i2cmaster_ReadLast = RoBoIO.i2cmaster_ReadLast

RoBoIO.i2cmaster_StartN.argtypes = [c_int, c_ubyte, c_ubyte, c_int]
RoBoIO.i2cmaster_StartN.restype = c_bool
i2cmaster_StartN = RoBoIO.i2cmaster_StartN

RoBoIO.i2cmaster_WriteN.argtypes = [c_int, c_ubyte]
RoBoIO.i2cmaster_WriteN.restype = c_bool
i2cmaster_WriteN = RoBoIO.i2cmaster_WriteN

RoBoIO.i2cmaster_ReadN.argtypes = [c_int]
RoBoIO.i2cmaster_ReadN.restype = c_uint
i2cmaster_ReadN = RoBoIO.i2cmaster_ReadN

RoBoIO.i2cmaster_SetRestart.argtypes = [c_int, c_ubyte, c_ubyte]
RoBoIO.i2cmaster_SetRestart.restype = c_bool
i2cmaster_SetRestart = RoBoIO.i2cmaster_SetRestart

RoBoIO.i2cmaster_SetRestartN.argtypes = [c_int, c_ubyte, c_int]
RoBoIO.i2cmaster_SetRestartN.restype = c_bool
i2cmaster_SetRestartN = RoBoIO.i2cmaster_SetRestartN

RoBoIO.i2cslave_Listen.argtypes = [c_int]
RoBoIO.i2cslave_Listen.restype = c_uint
i2cslave_Listen = RoBoIO.i2cslave_Listen

I2CSLAVE_NOTHING = (0)
I2CSLAVE_START = (1)
I2CSLAVE_END = (2)
I2CSLAVE_WAITING = (3)
I2CSLAVE_WRITEREQUEST = (4)
I2CSLAVE_READREQUEST = (5)
RoBoIO.i2cslave_Write.argtypes = [c_int, c_ubyte]
RoBoIO.i2cslave_Write.restype = c_bool
i2cslave_Write = RoBoIO.i2cslave_Write

RoBoIO.i2cslave_Read.argtypes = [c_int]
RoBoIO.i2cslave_Read.restype = c_uint
i2cslave_Read = RoBoIO.i2cslave_Read

RoBoIO.i2c_SetResetPin.argtypes = None
RoBoIO.i2c_SetResetPin.restype = None
i2c_SetResetPin = RoBoIO.i2c_SetResetPin

RoBoIO.i2c_ClearResetPin.argtypes = None
RoBoIO.i2c_ClearResetPin.restype = None
i2c_ClearResetPin = RoBoIO.i2c_ClearResetPin

RoBoIO.i2c0_SetSpeed.argtypes = [c_int, c_uint]
RoBoIO.i2c0_SetSpeed.restype = c_uint
i2c0_SetSpeed = RoBoIO.i2c0_SetSpeed

RoBoIO.i2c1_SetSpeed.argtypes = [c_int, c_uint]
RoBoIO.i2c1_SetSpeed.restype = c_uint
i2c1_SetSpeed = RoBoIO.i2c1_SetSpeed

RoBoIO.i2c0master_Start.argtypes = [c_ubyte, c_ubyte]
RoBoIO.i2c0master_Start.restype = c_bool
i2c0master_Start = RoBoIO.i2c0master_Start

RoBoIO.i2c1master_Start.argtypes = [c_ubyte, c_ubyte]
RoBoIO.i2c1master_Start.restype = c_bool
i2c1master_Start = RoBoIO.i2c1master_Start

RoBoIO.i2c0master_Write.argtypes = [c_ubyte]
RoBoIO.i2c0master_Write.restype = c_bool
i2c0master_Write = RoBoIO.i2c0master_Write

RoBoIO.i2c1master_Write.argtypes = [c_ubyte]
RoBoIO.i2c1master_Write.restype = c_bool
i2c1master_Write = RoBoIO.i2c1master_Write

RoBoIO.i2c0master_WriteLast.argtypes = [c_ubyte]
RoBoIO.i2c0master_WriteLast.restype = c_bool
i2c0master_WriteLast = RoBoIO.i2c0master_WriteLast

RoBoIO.i2c1master_WriteLast.argtypes = [c_ubyte]
RoBoIO.i2c1master_WriteLast.restype = c_bool
i2c1master_WriteLast = RoBoIO.i2c1master_WriteLast

RoBoIO.i2c0master_Read.argtypes = None
RoBoIO.i2c0master_Read.restype = c_uint
i2c0master_Read = RoBoIO.i2c0master_Read

RoBoIO.i2c1master_Read.argtypes = None
RoBoIO.i2c1master_Read.restype = c_uint
i2c1master_Read = RoBoIO.i2c1master_Read

RoBoIO.i2c0master_ReadSecondLast.argtypes = None
RoBoIO.i2c0master_ReadSecondLast.restype = c_uint
i2c0master_ReadSecondLast = RoBoIO.i2c0master_ReadSecondLast

RoBoIO.i2c1master_ReadSecondLast.argtypes = None
RoBoIO.i2c1master_ReadSecondLast.restype = c_uint
i2c1master_ReadSecondLast = RoBoIO.i2c1master_ReadSecondLast

RoBoIO.i2c0master_ReadLast.argtypes = None
RoBoIO.i2c0master_ReadLast.restype = c_uint
i2c0master_ReadLast = RoBoIO.i2c0master_ReadLast

RoBoIO.i2c1master_ReadLast.argtypes = None
RoBoIO.i2c1master_ReadLast.restype = c_uint
i2c1master_ReadLast = RoBoIO.i2c1master_ReadLast

RoBoIO.i2c0master_StartN.argtypes = [c_ubyte, c_ubyte, c_int]
RoBoIO.i2c0master_StartN.restype = c_bool
i2c0master_StartN = RoBoIO.i2c0master_StartN

RoBoIO.i2c1master_StartN.argtypes = [c_ubyte, c_ubyte, c_int]
RoBoIO.i2c1master_StartN.restype = c_bool
i2c1master_StartN = RoBoIO.i2c1master_StartN

RoBoIO.i2c0master_WriteN.argtypes = [c_ubyte]
RoBoIO.i2c0master_WriteN.restype = c_bool
i2c0master_WriteN = RoBoIO.i2c0master_WriteN

RoBoIO.i2c1master_WriteN.argtypes = [c_ubyte]
RoBoIO.i2c1master_WriteN.restype = c_bool
i2c1master_WriteN = RoBoIO.i2c1master_WriteN

RoBoIO.i2c0master_ReadN.argtypes = None
RoBoIO.i2c0master_ReadN.restype = c_uint
i2c0master_ReadN = RoBoIO.i2c0master_ReadN

RoBoIO.i2c1master_ReadN.argtypes = None
RoBoIO.i2c1master_ReadN.restype = c_uint
i2c1master_ReadN = RoBoIO.i2c1master_ReadN

RoBoIO.i2c0master_SetRestart.argtypes = [c_ubyte, c_ubyte]
RoBoIO.i2c0master_SetRestart.restype = c_bool
i2c0master_SetRestart = RoBoIO.i2c0master_SetRestart

RoBoIO.i2c1master_SetRestart.argtypes = [c_ubyte, c_ubyte]
RoBoIO.i2c1master_SetRestart.restype = c_bool
i2c1master_SetRestart = RoBoIO.i2c1master_SetRestart

RoBoIO.i2c0master_SetRestartN.argtypes = [c_ubyte, c_int]
RoBoIO.i2c0master_SetRestartN.restype = c_bool
i2c0master_SetRestartN = RoBoIO.i2c0master_SetRestartN

RoBoIO.i2c1master_SetRestartN.argtypes = [c_ubyte, c_int]
RoBoIO.i2c1master_SetRestartN.restype = c_bool
i2c1master_SetRestartN = RoBoIO.i2c1master_SetRestartN

RoBoIO.i2c0slave_Listen.argtypes = None
RoBoIO.i2c0slave_Listen.restype = c_uint
i2c0slave_Listen = RoBoIO.i2c0slave_Listen

RoBoIO.i2c1slave_Listen.argtypes = None
RoBoIO.i2c1slave_Listen.restype = c_uint
i2c1slave_Listen = RoBoIO.i2c1slave_Listen

RoBoIO.i2c0slave_Write.argtypes = [c_ubyte]
RoBoIO.i2c0slave_Write.restype = c_bool
i2c0slave_Write = RoBoIO.i2c0slave_Write

RoBoIO.i2c1slave_Write.argtypes = [c_ubyte]
RoBoIO.i2c1slave_Write.restype = c_bool
i2c1slave_Write = RoBoIO.i2c1slave_Write

RoBoIO.i2c0slave_Read.argtypes = None
RoBoIO.i2c0slave_Read.restype = c_uint
i2c0slave_Read = RoBoIO.i2c0slave_Read

RoBoIO.i2c1slave_Read.argtypes = None
RoBoIO.i2c1slave_Read.restype = c_uint
i2c1slave_Read = RoBoIO.i2c1slave_Read

RoBoIO.i2c_Initialize.argtypes = [c_int]
RoBoIO.i2c_Initialize.restype = c_bool
i2c_Initialize = RoBoIO.i2c_Initialize

RoBoIO.i2c_Init.argtypes = [c_int, c_uint]
RoBoIO.i2c_Init.restype = c_bool
i2c_Init = RoBoIO.i2c_Init

RoBoIO.i2c_InitSW.argtypes = [c_int, c_uint]
RoBoIO.i2c_InitSW.restype = c_bool
i2c_InitSW = RoBoIO.i2c_InitSW

RoBoIO.i2c_Send.argtypes = [c_ubyte, c_void_p, c_int]
RoBoIO.i2c_Send.restype = c_bool
#i2c_Send = RoBoIO.i2c_Send
def i2c_Send(addr, data, datasize):
    ubyte = c_ubyte * datasize
    temp = ubyte()
    for i in range(min(len(data), datasize)):
        temp[i] = data[i]
    return RoBoIO.i2c_Send(addr, temp, datasize)

RoBoIO.i2c_Receive.argtypes = [c_ubyte, c_void_p, c_int]
RoBoIO.i2c_Receive.restype = c_bool
#i2c_Receive = RoBoIO.i2c_Receive
def i2c_Receive(addr, buf, bufsize):
    if len(buf)<bufsize:
        for i in range(len(buf), bufsize):
            buf.append(0)
    ubyte = c_ubyte * bufsize
    temp = ubyte()
    if not RoBoIO.i2c_Receive(addr, temp, bufsize):
        return False
    for i in range(bufsize):
        buf[i] = temp[i]
    return  True

RoBoIO.i2c_SensorRead.argtypes = [c_ubyte, c_ubyte, c_void_p, c_int]
RoBoIO.i2c_SensorRead.restype = c_bool
#i2c_SensorRead = RoBoIO.i2c_SensorRead
def i2c_SensorRead(addr, cmd, buf, bufsize):
    if len(buf)<bufsize:
        for i in range(len(buf), bufsize):
            buf.append(0)
    ubyte = c_ubyte * bufsize
    temp = ubyte()
    if not RoBoIO.i2c_SensorRead(addr, cmd, temp, bufsize):
        return False
    for i in range(bufsize):
        buf[i] = temp[i]
    return  True

RoBoIO.i2c_SensorReadEX.argtypes = [c_ubyte, c_void_p, c_int, c_void_p, c_int]
RoBoIO.i2c_SensorReadEX.restype = c_bool
#i2c_SensorReadEX = RoBoIO.i2c_SensorReadEX
def i2c_SensorReadEX(addr, cmds, cmdsize, buf, bufsize):
    if len(buf)<bufsize:
        for i in range(len(buf), bufsize):
            buf.append(0)
    ubyte2 = c_type * cmdsize
    temp = ubyte2()
    ubyte = c_ubyte * bufsize
    temp2 = ubyte()
    for i in range(min(len(cmds), cmdsize)):
        temp[i] = cmds[i]
    if not RoBoIO.i2c_SensorReadEX(addr, temp, cmdsize, temp2, bufsize):
        return False
    for i in range(bufsize):
        buf[i] = temp2[i]
    return True

#i2cdx.h
RoBoIO.i2c_SetBaseAddress.argtypes = [c_uint]
RoBoIO.i2c_SetBaseAddress.restype = None
i2c_SetBaseAddress = RoBoIO.i2c_SetBaseAddress

RoBoIO.i2c_SetDefaultBaseAddress.argtypes = None
RoBoIO.i2c_SetDefaultBaseAddress.restype = c_uint
i2c_SetDefaultBaseAddress = RoBoIO.i2c_SetDefaultBaseAddress

RoBoIO.i2c_SetIRQ.argtypes = [c_int, c_int]
RoBoIO.i2c_SetIRQ.restype = None
i2c_SetIRQ = RoBoIO.i2c_SetIRQ

I2CIRQ1 = (8)
I2CIRQ3 = (2)
I2CIRQ4 = (4)
I2CIRQ5 = (5)
I2CIRQ6 = (7)
I2CIRQ7 = (6)
I2CIRQ9 = (1)
I2CIRQ10 = (3)
I2CIRQ11 = (9)
I2CIRQ12 = (11)
I2CIRQ14 = (13)
I2CIRQ15 = (15)
I2CIRQ_DISABLE = (0)
RoBoIO.i2c_Reset.argtypes = [c_int]
RoBoIO.i2c_Reset.restype = c_bool
i2c_Reset = RoBoIO.i2c_Reset

ERROR_I2CFAIL = (ERR_NOERROR + 620)
RoBoIO.i2c_EnableNoiseFilter.argtypes = [c_int]
RoBoIO.i2c_EnableNoiseFilter.restype = None
i2c_EnableNoiseFilter = RoBoIO.i2c_EnableNoiseFilter

RoBoIO.i2c_DisableNoiseFilter.argtypes = [c_int]
RoBoIO.i2c_DisableNoiseFilter.restype = None
i2c_DisableNoiseFilter = RoBoIO.i2c_DisableNoiseFilter

RoBoIO.i2c_EnableStandardHSM.argtypes = [c_int]
RoBoIO.i2c_EnableStandardHSM.restype = None
i2c_EnableStandardHSM = RoBoIO.i2c_EnableStandardHSM

RoBoIO.i2c_DisableStandardHSM.argtypes = [c_int]
RoBoIO.i2c_DisableStandardHSM.restype = None
i2c_DisableStandardHSM = RoBoIO.i2c_DisableStandardHSM

RoBoIO.i2c_EnableINT.argtypes = [c_int, c_ubyte]
RoBoIO.i2c_EnableINT.restype = None
i2c_EnableINT = RoBoIO.i2c_EnableINT

RoBoIO.i2c_DisableINT.argtypes = [c_int, c_ubyte]
RoBoIO.i2c_DisableINT.restype = None
i2c_DisableINT = RoBoIO.i2c_DisableINT

I2CINT_SLAVEWREQ = (0x80)
I2CINT_RXRDY = (0x40)
I2CINT_TXDONE = (0x20)
I2CINT_ACKERR = (0x10)
I2CINT_ARLOSS = (0x08)
I2CINT_SLAVESTOPPED = (0x04)
I2CINT_ALL = (0xfc)
RoBoIO.i2c_SetCLKREG.argtypes = [c_int, c_int, c_ubyte, c_ubyte]
RoBoIO.i2c_SetCLKREG.restype = None
i2c_SetCLKREG = RoBoIO.i2c_SetCLKREG

I2CMODE_STANDARD = (0)
I2CMODE_FAST = (1)
RoBoIO.i2c_ClearSTAT.argtypes = [c_int, c_ubyte]
RoBoIO.i2c_ClearSTAT.restype = None
i2c_ClearSTAT = RoBoIO.i2c_ClearSTAT

I2CSTAT_SLAVEWREQ = (0x80)
I2CSTAT_RXRDY = (0x40)
I2CSTAT_TXDONE = (0x20)
I2CSTAT_ACKERR = (0x10)
I2CSTAT_ARLOSS = (0x08)
I2CSTAT_SLAVESTOPPED = (0x04)
I2CSTAT_ALL = (0xfc)
RoBoIO.i2c_ReadStatREG.argtypes = [c_int]
RoBoIO.i2c_ReadStatREG.restype = c_ubyte
i2c_ReadStatREG = RoBoIO.i2c_ReadStatREG

RoBoIO.i2c_IsMaster.argtypes = [c_int]
RoBoIO.i2c_IsMaster.restype = c_bool
i2c_IsMaster = RoBoIO.i2c_IsMaster

RoBoIO.i2c_CheckBusBusy.argtypes = [c_int]
RoBoIO.i2c_CheckBusBusy.restype = c_bool
i2c_CheckBusBusy = RoBoIO.i2c_CheckBusBusy

RoBoIO.i2c_CheckTXDone.argtypes = [c_int]
RoBoIO.i2c_CheckTXDone.restype = c_bool
i2c_CheckTXDone = RoBoIO.i2c_CheckTXDone

RoBoIO.i2c_ClearTXDone.argtypes = [c_int]
RoBoIO.i2c_ClearTXDone.restype = None
i2c_ClearTXDone = RoBoIO.i2c_ClearTXDone

RoBoIO.i2c_CheckRXRdy.argtypes = [c_int]
RoBoIO.i2c_CheckRXRdy.restype = c_bool
i2c_CheckRXRdy = RoBoIO.i2c_CheckRXRdy

RoBoIO.i2c_ClearRXRdy.argtypes = [c_int]
RoBoIO.i2c_ClearRXRdy.restype = None
i2c_ClearRXRdy = RoBoIO.i2c_ClearRXRdy

RoBoIO.i2c_WriteDataREG.argtypes = [c_int, c_ubyte]
RoBoIO.i2c_WriteDataREG.restype = None
i2c_WriteDataREG = RoBoIO.i2c_WriteDataREG

RoBoIO.i2c_ReadDataREG.argtypes = [c_int]
RoBoIO.i2c_ReadDataREG.restype = c_ubyte
i2c_ReadDataREG = RoBoIO.i2c_ReadDataREG

RoBoIO.i2cmaster_SetStopBit.argtypes = [c_int]
RoBoIO.i2cmaster_SetStopBit.restype = None
i2cmaster_SetStopBit = RoBoIO.i2cmaster_SetStopBit

RoBoIO.i2cmaster_CheckStopBit.argtypes = [c_int]
RoBoIO.i2cmaster_CheckStopBit.restype = c_bool
i2cmaster_CheckStopBit = RoBoIO.i2cmaster_CheckStopBit

RoBoIO.i2cmaster_CheckARLoss.argtypes = [c_int]
RoBoIO.i2cmaster_CheckARLoss.restype = c_bool
i2cmaster_CheckARLoss = RoBoIO.i2cmaster_CheckARLoss

RoBoIO.i2cmaster_ClearARLoss.argtypes = [c_int]
RoBoIO.i2cmaster_ClearARLoss.restype = None
i2cmaster_ClearARLoss = RoBoIO.i2cmaster_ClearARLoss

RoBoIO.i2cmaster_CheckAckErr.argtypes = [c_int]
RoBoIO.i2cmaster_CheckAckErr.restype = c_bool
i2cmaster_CheckAckErr = RoBoIO.i2cmaster_CheckAckErr

RoBoIO.i2cmaster_ClearAckErr.argtypes = [c_int]
RoBoIO.i2cmaster_ClearAckErr.restype = None
i2cmaster_ClearAckErr = RoBoIO.i2cmaster_ClearAckErr

RoBoIO.i2cmaster_WriteAddrREG.argtypes = [c_int, c_ubyte, c_ubyte]
RoBoIO.i2cmaster_WriteAddrREG.restype = None
i2cmaster_WriteAddrREG = RoBoIO.i2cmaster_WriteAddrREG

I2C_WRITE = (0)
I2C_READ = (1)
RoBoIO.i2cslave_EnableACK.argtypes = [c_int]
RoBoIO.i2cslave_EnableACK.restype = None
i2cslave_EnableACK = RoBoIO.i2cslave_EnableACK

RoBoIO.i2cslave_EnableNAK.argtypes = [c_int]
RoBoIO.i2cslave_EnableNAK.restype = None
i2cslave_EnableNAK = RoBoIO.i2cslave_EnableNAK

RoBoIO.i2cslave_SetAddr.argtypes = [c_int, c_ubyte]
RoBoIO.i2cslave_SetAddr.restype = None
i2cslave_SetAddr = RoBoIO.i2cslave_SetAddr

RoBoIO.i2cslave_CheckSlaveWREQ.argtypes = [c_int]
RoBoIO.i2cslave_CheckSlaveWREQ.restype = c_bool
i2cslave_CheckSlaveWREQ = RoBoIO.i2cslave_CheckSlaveWREQ

RoBoIO.i2cslave_ClearSlaveWREQ.argtypes = [c_int]
RoBoIO.i2cslave_ClearSlaveWREQ.restype = None
i2cslave_ClearSlaveWREQ = RoBoIO.i2cslave_ClearSlaveWREQ

RoBoIO.i2c0_Reset.argtypes = None
RoBoIO.i2c0_Reset.restype = c_bool
i2c0_Reset = RoBoIO.i2c0_Reset

RoBoIO.i2c1_Reset.argtypes = None
RoBoIO.i2c1_Reset.restype = c_bool
i2c1_Reset = RoBoIO.i2c1_Reset

RoBoIO.i2c0_EnableNoiseFilter.argtypes = None
RoBoIO.i2c0_EnableNoiseFilter.restype = None
i2c0_EnableNoiseFilter = RoBoIO.i2c0_EnableNoiseFilter

RoBoIO.i2c1_EnableNoiseFilter.argtypes = None
RoBoIO.i2c1_EnableNoiseFilter.restype = None
i2c1_EnableNoiseFilter = RoBoIO.i2c1_EnableNoiseFilter

RoBoIO.i2c0_DisableNoiseFilter.argtypes = None
RoBoIO.i2c0_DisableNoiseFilter.restype = None
i2c0_DisableNoiseFilter = RoBoIO.i2c0_DisableNoiseFilter

RoBoIO.i2c1_DisableNoiseFilter.argtypes = None
RoBoIO.i2c1_DisableNoiseFilter.restype = None
i2c1_DisableNoiseFilter = RoBoIO.i2c1_DisableNoiseFilter

RoBoIO.i2c0_EnableStandardHSM.argtypes = None
RoBoIO.i2c0_EnableStandardHSM.restype = None
i2c0_EnableStandardHSM = RoBoIO.i2c0_EnableStandardHSM

RoBoIO.i2c1_EnableStandardHSM.argtypes = None
RoBoIO.i2c1_EnableStandardHSM.restype = None
i2c1_EnableStandardHSM = RoBoIO.i2c1_EnableStandardHSM

RoBoIO.i2c0_DisableStandardHSM.argtypes = None
RoBoIO.i2c0_DisableStandardHSM.restype = None
i2c0_DisableStandardHSM = RoBoIO.i2c0_DisableStandardHSM

RoBoIO.i2c1_DisableStandardHSM.argtypes = None
RoBoIO.i2c1_DisableStandardHSM.restype = None
i2c1_DisableStandardHSM = RoBoIO.i2c1_DisableStandardHSM

RoBoIO.i2c0_EnableINT.argtypes = [c_ubyte]
RoBoIO.i2c0_EnableINT.restype = None
i2c0_EnableINT = RoBoIO.i2c0_EnableINT

RoBoIO.i2c1_EnableINT.argtypes = [c_ubyte]
RoBoIO.i2c1_EnableINT.restype = None
i2c1_EnableINT = RoBoIO.i2c1_EnableINT

RoBoIO.i2c0_DisableINT.argtypes = [c_ubyte]
RoBoIO.i2c0_DisableINT.restype = None
i2c0_DisableINT = RoBoIO.i2c0_DisableINT

RoBoIO.i2c1_DisableINT.argtypes = [c_ubyte]
RoBoIO.i2c1_DisableINT.restype = None
i2c1_DisableINT = RoBoIO.i2c1_DisableINT

RoBoIO.i2c0_SetCLKREG.argtypes = [c_int, c_ubyte, c_ubyte]
RoBoIO.i2c0_SetCLKREG.restype = None
i2c0_SetCLKREG = RoBoIO.i2c0_SetCLKREG

RoBoIO.i2c1_SetCLKREG.argtypes = [c_int, c_ubyte, c_ubyte]
RoBoIO.i2c1_SetCLKREG.restype = None
i2c1_SetCLKREG = RoBoIO.i2c1_SetCLKREG

RoBoIO.i2c0_ClearSTAT.argtypes = [c_ubyte]
RoBoIO.i2c0_ClearSTAT.restype = None
i2c0_ClearSTAT = RoBoIO.i2c0_ClearSTAT

RoBoIO.i2c1_ClearSTAT.argtypes = [c_ubyte]
RoBoIO.i2c1_ClearSTAT.restype = None
i2c1_ClearSTAT = RoBoIO.i2c1_ClearSTAT

RoBoIO.i2c0_ReadStatREG.argtypes = None
RoBoIO.i2c0_ReadStatREG.restype = c_ubyte
i2c0_ReadStatREG = RoBoIO.i2c0_ReadStatREG

RoBoIO.i2c1_ReadStatREG.argtypes = None
RoBoIO.i2c1_ReadStatREG.restype = c_ubyte
i2c1_ReadStatREG = RoBoIO.i2c1_ReadStatREG

RoBoIO.i2c0_IsMaster.argtypes = None
RoBoIO.i2c0_IsMaster.restype = c_bool
i2c0_IsMaster = RoBoIO.i2c0_IsMaster

RoBoIO.i2c1_IsMaster.argtypes = None
RoBoIO.i2c1_IsMaster.restype = c_bool
i2c1_IsMaster = RoBoIO.i2c1_IsMaster

RoBoIO.i2c0_CheckBusBusy.argtypes = None
RoBoIO.i2c0_CheckBusBusy.restype = c_bool
i2c0_CheckBusBusy = RoBoIO.i2c0_CheckBusBusy

RoBoIO.i2c1_CheckBusBusy.argtypes = None
RoBoIO.i2c1_CheckBusBusy.restype = c_bool
i2c1_CheckBusBusy = RoBoIO.i2c1_CheckBusBusy

RoBoIO.i2c0_CheckTXDone.argtypes = None
RoBoIO.i2c0_CheckTXDone.restype = c_bool
i2c0_CheckTXDone = RoBoIO.i2c0_CheckTXDone

RoBoIO.i2c1_CheckTXDone.argtypes = None
RoBoIO.i2c1_CheckTXDone.restype = c_bool
i2c1_CheckTXDone = RoBoIO.i2c1_CheckTXDone

RoBoIO.i2c0_ClearTXDone.argtypes = None
RoBoIO.i2c0_ClearTXDone.restype = None
i2c0_ClearTXDone = RoBoIO.i2c0_ClearTXDone

RoBoIO.i2c1_ClearTXDone.argtypes = None
RoBoIO.i2c1_ClearTXDone.restype = None
i2c1_ClearTXDone = RoBoIO.i2c1_ClearTXDone

RoBoIO.i2c0_CheckRXRdy.argtypes = None
RoBoIO.i2c0_CheckRXRdy.restype = c_bool
i2c0_CheckRXRdy = RoBoIO.i2c0_CheckRXRdy

RoBoIO.i2c1_CheckRXRdy.argtypes = None
RoBoIO.i2c1_CheckRXRdy.restype = c_bool
i2c1_CheckRXRdy = RoBoIO.i2c1_CheckRXRdy

RoBoIO.i2c0_ClearRXRdy.argtypes = None
RoBoIO.i2c0_ClearRXRdy.restype = None
i2c0_ClearRXRdy = RoBoIO.i2c0_ClearRXRdy

RoBoIO.i2c1_ClearRXRdy.argtypes = None
RoBoIO.i2c1_ClearRXRdy.restype = None
i2c1_ClearRXRdy = RoBoIO.i2c1_ClearRXRdy

RoBoIO.i2c0_WriteDataREG.argtypes = [c_ubyte]
RoBoIO.i2c0_WriteDataREG.restype = None
i2c0_WriteDataREG = RoBoIO.i2c0_WriteDataREG

RoBoIO.i2c1_WriteDataREG.argtypes = [c_ubyte]
RoBoIO.i2c1_WriteDataREG.restype = None
i2c1_WriteDataREG = RoBoIO.i2c1_WriteDataREG

RoBoIO.i2c0_ReadDataREG.argtypes = None
RoBoIO.i2c0_ReadDataREG.restype = c_ubyte
i2c0_ReadDataREG = RoBoIO.i2c0_ReadDataREG

RoBoIO.i2c1_ReadDataREG.argtypes = None
RoBoIO.i2c1_ReadDataREG.restype = c_ubyte
i2c1_ReadDataREG = RoBoIO.i2c1_ReadDataREG

RoBoIO.i2c0master_SetStopBit.argtypes = None
RoBoIO.i2c0master_SetStopBit.restype = None
i2c0master_SetStopBit = RoBoIO.i2c0master_SetStopBit

RoBoIO.i2c1master_SetStopBit.argtypes = None
RoBoIO.i2c1master_SetStopBit.restype = None
i2c1master_SetStopBit = RoBoIO.i2c1master_SetStopBit

RoBoIO.i2c0master_CheckStopBit.argtypes = None
RoBoIO.i2c0master_CheckStopBit.restype = c_bool
i2c0master_CheckStopBit = RoBoIO.i2c0master_CheckStopBit

RoBoIO.i2c1master_CheckStopBit.argtypes = None
RoBoIO.i2c1master_CheckStopBit.restype = c_bool
i2c1master_CheckStopBit = RoBoIO.i2c1master_CheckStopBit

RoBoIO.i2c0master_CheckARLoss.argtypes = None
RoBoIO.i2c0master_CheckARLoss.restype = c_bool
i2c0master_CheckARLoss = RoBoIO.i2c0master_CheckARLoss

RoBoIO.i2c1master_CheckARLoss.argtypes = None
RoBoIO.i2c1master_CheckARLoss.restype = c_bool
i2c1master_CheckARLoss = RoBoIO.i2c1master_CheckARLoss

RoBoIO.i2c0master_ClearARLoss.argtypes = None
RoBoIO.i2c0master_ClearARLoss.restype = None
i2c0master_ClearARLoss = RoBoIO.i2c0master_ClearARLoss

RoBoIO.i2c1master_ClearARLoss.argtypes = None
RoBoIO.i2c1master_ClearARLoss.restype = None
i2c1master_ClearARLoss = RoBoIO.i2c1master_ClearARLoss

RoBoIO.i2c0master_CheckAckErr.argtypes = None
RoBoIO.i2c0master_CheckAckErr.restype = c_bool
i2c0master_CheckAckErr = RoBoIO.i2c0master_CheckAckErr

RoBoIO.i2c1master_CheckAckErr.argtypes = None
RoBoIO.i2c1master_CheckAckErr.restype = c_bool
i2c1master_CheckAckErr = RoBoIO.i2c1master_CheckAckErr

RoBoIO.i2c0master_ClearAckErr.argtypes = None
RoBoIO.i2c0master_ClearAckErr.restype = None
i2c0master_ClearAckErr = RoBoIO.i2c0master_ClearAckErr

RoBoIO.i2c1master_ClearAckErr.argtypes = None
RoBoIO.i2c1master_ClearAckErr.restype = None
i2c1master_ClearAckErr = RoBoIO.i2c1master_ClearAckErr

RoBoIO.i2c0master_WriteAddrREG.argtypes = [c_ubyte, c_ubyte]
RoBoIO.i2c0master_WriteAddrREG.restype = None
i2c0master_WriteAddrREG = RoBoIO.i2c0master_WriteAddrREG

RoBoIO.i2c1master_WriteAddrREG.argtypes = [c_ubyte, c_ubyte]
RoBoIO.i2c1master_WriteAddrREG.restype = None
i2c1master_WriteAddrREG = RoBoIO.i2c1master_WriteAddrREG

RoBoIO.i2c0slave_EnableACK.argtypes = None
RoBoIO.i2c0slave_EnableACK.restype = None
i2c0slave_EnableACK = RoBoIO.i2c0slave_EnableACK

RoBoIO.i2c1slave_EnableACK.argtypes = None
RoBoIO.i2c1slave_EnableACK.restype = None
i2c1slave_EnableACK = RoBoIO.i2c1slave_EnableACK

RoBoIO.i2c0slave_EnableNAK.argtypes = None
RoBoIO.i2c0slave_EnableNAK.restype = None
i2c0slave_EnableNAK = RoBoIO.i2c0slave_EnableNAK

RoBoIO.i2c1slave_EnableNAK.argtypes = None
RoBoIO.i2c1slave_EnableNAK.restype = None
i2c1slave_EnableNAK = RoBoIO.i2c1slave_EnableNAK

RoBoIO.i2c0slave_SetAddr.argtypes = [c_ubyte]
RoBoIO.i2c0slave_SetAddr.restype = None
i2c0slave_SetAddr = RoBoIO.i2c0slave_SetAddr

RoBoIO.i2c1slave_SetAddr.argtypes = [c_ubyte]
RoBoIO.i2c1slave_SetAddr.restype = None
i2c1slave_SetAddr = RoBoIO.i2c1slave_SetAddr

RoBoIO.i2c0slave_CheckSlaveWREQ.argtypes = None
RoBoIO.i2c0slave_CheckSlaveWREQ.restype = c_bool
i2c0slave_CheckSlaveWREQ = RoBoIO.i2c0slave_CheckSlaveWREQ

RoBoIO.i2c1slave_CheckSlaveWREQ.argtypes = None
RoBoIO.i2c1slave_CheckSlaveWREQ.restype = c_bool
i2c1slave_CheckSlaveWREQ = RoBoIO.i2c1slave_CheckSlaveWREQ

RoBoIO.i2c0slave_ClearSlaveWREQ.argtypes = None
RoBoIO.i2c0slave_ClearSlaveWREQ.restype = None
i2c0slave_ClearSlaveWREQ = RoBoIO.i2c0slave_ClearSlaveWREQ

RoBoIO.i2c1slave_ClearSlaveWREQ.argtypes = None
RoBoIO.i2c1slave_ClearSlaveWREQ.restype = None
i2c1slave_ClearSlaveWREQ = RoBoIO.i2c1slave_ClearSlaveWREQ

#pwm.h
RoBoIO.pwm_NumCh.argtypes = None
RoBoIO.pwm_NumCh.restype = c_int
pwm_NumCh = RoBoIO.pwm_NumCh

RoBoIO.pwm_InUse.argtypes = None
RoBoIO.pwm_InUse.restype = c_bool
pwm_InUse = RoBoIO.pwm_InUse

RoBoIO.pwm_Init2.argtypes = [c_uint, c_int, c_int]
RoBoIO.pwm_Init2.restype = c_bool
pwm_Init2 = RoBoIO.pwm_Init2

ERROR_PWM_INUSE = (ERR_NOERROR + 300)
RoBoIO.pwm_Close.argtypes = None
RoBoIO.pwm_Close.restype = None
pwm_Close = RoBoIO.pwm_Close

RoBoIO.pwm_SetBaseClock.argtypes = [c_int]
RoBoIO.pwm_SetBaseClock.restype = None
pwm_SetBaseClock = RoBoIO.pwm_SetBaseClock

RoBoIO.pwm_SetPulse.argtypes = [c_int, c_uint, c_uint]
RoBoIO.pwm_SetPulse.restype = c_bool
pwm_SetPulse = RoBoIO.pwm_SetPulse

RoBoIO.pwm_SetPulse_10MHZ.argtypes = [c_int, c_uint, c_uint]
RoBoIO.pwm_SetPulse_10MHZ.restype = c_bool
pwm_SetPulse_10MHZ = RoBoIO.pwm_SetPulse_10MHZ

RoBoIO.pwm_SetPulse_50MHZ.argtypes = [c_int, c_uint, c_uint]
RoBoIO.pwm_SetPulse_50MHZ.restype = c_bool
pwm_SetPulse_50MHZ = RoBoIO.pwm_SetPulse_50MHZ

ERROR_PWM_WRONGCHANNEL = (ERR_NOERROR + 310)
ERROR_PWM_INVALIDPULSE = (ERR_NOERROR + 311)
ERROR_PWM_CLOCKMISMATCH = (ERR_NOERROR + 312)
RoBoIO.pwm_EnablePin.argtypes = [c_int]
RoBoIO.pwm_EnablePin.restype = None
pwm_EnablePin = RoBoIO.pwm_EnablePin

RoBoIO.pwm_DisablePin.argtypes = [c_int]
RoBoIO.pwm_DisablePin.restype = None
pwm_DisablePin = RoBoIO.pwm_DisablePin

RoBoIO.pwm_EnableMultiPin.argtypes = [c_uint]
RoBoIO.pwm_EnableMultiPin.restype = None
pwm_EnableMultiPin = RoBoIO.pwm_EnableMultiPin

RoBoIO.pwm_DisableMultiPin.argtypes = [c_uint]
RoBoIO.pwm_DisableMultiPin.restype = None
pwm_DisableMultiPin = RoBoIO.pwm_DisableMultiPin

RoBoIO.pwm_Lock.argtypes = [c_int]
RoBoIO.pwm_Lock.restype = None
pwm_Lock = RoBoIO.pwm_Lock

RoBoIO.pwm_Unlock.argtypes = [c_int]
RoBoIO.pwm_Unlock.restype = None
pwm_Unlock = RoBoIO.pwm_Unlock

RoBoIO.pwm_LockMulti.argtypes = [c_uint]
RoBoIO.pwm_LockMulti.restype = None
pwm_LockMulti = RoBoIO.pwm_LockMulti

RoBoIO.pwm_UnlockMulti.argtypes = [c_uint]
RoBoIO.pwm_UnlockMulti.restype = None
pwm_UnlockMulti = RoBoIO.pwm_UnlockMulti

RoBoIO.pwm_EnableINT.argtypes = [c_int]
RoBoIO.pwm_EnableINT.restype = None
pwm_EnableINT = RoBoIO.pwm_EnableINT

RoBoIO.pwm_DisableINT.argtypes = [c_int]
RoBoIO.pwm_DisableINT.restype = None
pwm_DisableINT = RoBoIO.pwm_DisableINT

RoBoIO.pwm_EnableMultiINT.argtypes = [c_uint]
RoBoIO.pwm_EnableMultiINT.restype = None
pwm_EnableMultiINT = RoBoIO.pwm_EnableMultiINT

RoBoIO.pwm_DisableMultiINT.argtypes = [c_uint]
RoBoIO.pwm_DisableMultiINT.restype = None
pwm_DisableMultiINT = RoBoIO.pwm_DisableMultiINT

RoBoIO.pwm_ClearMultiFLAG.argtypes = [c_uint]
RoBoIO.pwm_ClearMultiFLAG.restype = None
pwm_ClearMultiFLAG = RoBoIO.pwm_ClearMultiFLAG

RoBoIO.pwm_ReadMultiFLAG.argtypes = [c_uint]
RoBoIO.pwm_ReadMultiFLAG.restype = c_uint
pwm_ReadMultiFLAG = RoBoIO.pwm_ReadMultiFLAG

RoBoIO.pwm_EnablePWM.argtypes = [c_int]
RoBoIO.pwm_EnablePWM.restype = None
pwm_EnablePWM = RoBoIO.pwm_EnablePWM

RoBoIO.pwm_DisablePWM.argtypes = [c_int]
RoBoIO.pwm_DisablePWM.restype = None
pwm_DisablePWM = RoBoIO.pwm_DisablePWM

RoBoIO.pwm_EnableMultiPWM.argtypes = [c_uint]
RoBoIO.pwm_EnableMultiPWM.restype = None
pwm_EnableMultiPWM = RoBoIO.pwm_EnableMultiPWM

RoBoIO.pwm_DisableMultiPWM.argtypes = [c_uint]
RoBoIO.pwm_DisableMultiPWM.restype = None
pwm_DisableMultiPWM = RoBoIO.pwm_DisableMultiPWM

RoBoIO.pwm_ReadCountingMode.argtypes = [c_int]
RoBoIO.pwm_ReadCountingMode.restype = c_int
pwm_ReadCountingMode = RoBoIO.pwm_ReadCountingMode

RoBoIO.pwm_SetCountingMode.argtypes = [c_int, c_int]
RoBoIO.pwm_SetCountingMode.restype = None
pwm_SetCountingMode = RoBoIO.pwm_SetCountingMode

RoBoIO.pwm_SetWaveform.argtypes = [c_int, c_int]
RoBoIO.pwm_SetWaveform.restype = None
pwm_SetWaveform = RoBoIO.pwm_SetWaveform

RoBoIO.pwm_SetPulseCount.argtypes = [c_int, c_uint]
RoBoIO.pwm_SetPulseCount.restype = None
pwm_SetPulseCount = RoBoIO.pwm_SetPulseCount

RoBoIO.pwm_SetCtrlREG.argtypes = [c_int, c_uint]
RoBoIO.pwm_SetCtrlREG.restype = None
pwm_SetCtrlREG = RoBoIO.pwm_SetCtrlREG

RoBoIO.pwm_SetHREG.argtypes = [c_int, c_uint]
RoBoIO.pwm_SetHREG.restype = None
pwm_SetHREG = RoBoIO.pwm_SetHREG

RoBoIO.pwm_SetLREG.argtypes = [c_int, c_uint]
RoBoIO.pwm_SetLREG.restype = None
pwm_SetLREG = RoBoIO.pwm_SetLREG

RoBoIO.pwm_ReadPulseCount.argtypes = [c_int]
RoBoIO.pwm_ReadPulseCount.restype = c_uint
pwm_ReadPulseCount = RoBoIO.pwm_ReadPulseCount

RoBoIO.pwm_ReadCtrlREG.argtypes = [c_int]
RoBoIO.pwm_ReadCtrlREG.restype = c_uint
pwm_ReadCtrlREG = RoBoIO.pwm_ReadCtrlREG

RoBoIO.pwm_ReadHREG.argtypes = [c_int]
RoBoIO.pwm_ReadHREG.restype = c_uint
pwm_ReadHREG = RoBoIO.pwm_ReadHREG

RoBoIO.pwm_ReadLREG.argtypes = [c_int]
RoBoIO.pwm_ReadLREG.restype = c_uint
pwm_ReadLREG = RoBoIO.pwm_ReadLREG

RoBoIO.pwm_Initialize.argtypes = [c_uint, c_int, c_int]
RoBoIO.pwm_Initialize.restype = c_bool
pwm_Initialize = RoBoIO.pwm_Initialize

RoBoIO.pwm_Init.argtypes = None
RoBoIO.pwm_Init.restype = c_bool
pwm_Init = RoBoIO.pwm_Init

#pwmdx.h
RoBoIO.pwm_SetBaseAddress.argtypes = [c_uint]
RoBoIO.pwm_SetBaseAddress.restype = None
pwm_SetBaseAddress = RoBoIO.pwm_SetBaseAddress

RoBoIO.pwm_SetDefaultBaseAddress.argtypes = None
RoBoIO.pwm_SetDefaultBaseAddress.restype = c_uint
pwm_SetDefaultBaseAddress = RoBoIO.pwm_SetDefaultBaseAddress

RoBoIO.pwm_SelectClock.argtypes = [c_int]
RoBoIO.pwm_SelectClock.restype = None
pwm_SelectClock = RoBoIO.pwm_SelectClock

PWMCLOCK_10MHZ = (0)
PWMCLOCK_50MHZ = (1)
RoBoIO.pwm_SetIRQ.argtypes = [c_int]
RoBoIO.pwm_SetIRQ.restype = None
pwm_SetIRQ = RoBoIO.pwm_SetIRQ

PWMIRQ1 = (8)
PWMIRQ3 = (2)
PWMIRQ4 = (4)
PWMIRQ5 = (5)
PWMIRQ6 = (7)
PWMIRQ7 = (6)
PWMIRQ9 = (1)
PWMIRQ10 = (3)
PWMIRQ11 = (9)
PWMIRQ12 = (11)
PWMIRQ14 = (13)
PWMIRQ15 = (15)
PWMIRQ_DISABLE = (0)
RoBoIO.pwmdx_EnablePin.argtypes = [c_int]
RoBoIO.pwmdx_EnablePin.restype = None
pwmdx_EnablePin = RoBoIO.pwmdx_EnablePin

RoBoIO.pwmdx_DisablePin.argtypes = [c_int]
RoBoIO.pwmdx_DisablePin.restype = None
pwmdx_DisablePin = RoBoIO.pwmdx_DisablePin

RoBoIO.pwmdx_EnableMultiPin.argtypes = [c_uint]
RoBoIO.pwmdx_EnableMultiPin.restype = None
pwmdx_EnableMultiPin = RoBoIO.pwmdx_EnableMultiPin

RoBoIO.pwmdx_DisableMultiPin.argtypes = [c_uint]
RoBoIO.pwmdx_DisableMultiPin.restype = None
pwmdx_DisableMultiPin = RoBoIO.pwmdx_DisableMultiPin

RoBoIO.pwmdx_Lock.argtypes = [c_int]
RoBoIO.pwmdx_Lock.restype = None
pwmdx_Lock = RoBoIO.pwmdx_Lock

RoBoIO.pwmdx_Unlock.argtypes = [c_int]
RoBoIO.pwmdx_Unlock.restype = None
pwmdx_Unlock = RoBoIO.pwmdx_Unlock

RoBoIO.pwmdx_LockMulti.argtypes = [c_uint]
RoBoIO.pwmdx_LockMulti.restype = None
pwmdx_LockMulti = RoBoIO.pwmdx_LockMulti

RoBoIO.pwmdx_UnlockMulti.argtypes = [c_uint]
RoBoIO.pwmdx_UnlockMulti.restype = None
pwmdx_UnlockMulti = RoBoIO.pwmdx_UnlockMulti

RoBoIO.pwmdx_EnableINT.argtypes = [c_int]
RoBoIO.pwmdx_EnableINT.restype = None
pwmdx_EnableINT = RoBoIO.pwmdx_EnableINT

RoBoIO.pwmdx_DisableINT.argtypes = [c_int]
RoBoIO.pwmdx_DisableINT.restype = None
pwmdx_DisableINT = RoBoIO.pwmdx_DisableINT

RoBoIO.pwmdx_EnableMultiINT.argtypes = [c_uint]
RoBoIO.pwmdx_EnableMultiINT.restype = None
pwmdx_EnableMultiINT = RoBoIO.pwmdx_EnableMultiINT

RoBoIO.pwmdx_DisableMultiINT.argtypes = [c_uint]
RoBoIO.pwmdx_DisableMultiINT.restype = None
pwmdx_DisableMultiINT = RoBoIO.pwmdx_DisableMultiINT

RoBoIO.pwmdx_ClearMultiFLAG.argtypes = [c_uint]
RoBoIO.pwmdx_ClearMultiFLAG.restype = None
pwmdx_ClearMultiFLAG = RoBoIO.pwmdx_ClearMultiFLAG

RoBoIO.pwmdx_ReadMultiFLAG.argtypes = [c_uint]
RoBoIO.pwmdx_ReadMultiFLAG.restype = c_uint
pwmdx_ReadMultiFLAG = RoBoIO.pwmdx_ReadMultiFLAG

RoBoIO.pwmdx_EnablePWM.argtypes = [c_int]
RoBoIO.pwmdx_EnablePWM.restype = None
pwmdx_EnablePWM = RoBoIO.pwmdx_EnablePWM

RoBoIO.pwmdx_DisablePWM.argtypes = [c_int]
RoBoIO.pwmdx_DisablePWM.restype = None
pwmdx_DisablePWM = RoBoIO.pwmdx_DisablePWM

RoBoIO.pwmdx_EnableMultiPWM.argtypes = [c_uint]
RoBoIO.pwmdx_EnableMultiPWM.restype = None
pwmdx_EnableMultiPWM = RoBoIO.pwmdx_EnableMultiPWM

RoBoIO.pwmdx_DisableMultiPWM.argtypes = [c_uint]
RoBoIO.pwmdx_DisableMultiPWM.restype = None
pwmdx_DisableMultiPWM = RoBoIO.pwmdx_DisableMultiPWM

RoBoIO.pwmdx_ReadCountingMode.argtypes = [c_int]
RoBoIO.pwmdx_ReadCountingMode.restype = c_int
pwmdx_ReadCountingMode = RoBoIO.pwmdx_ReadCountingMode

RoBoIO.pwmdx_SetCountingMode.argtypes = [c_int, c_int]
RoBoIO.pwmdx_SetCountingMode.restype = None
pwmdx_SetCountingMode = RoBoIO.pwmdx_SetCountingMode

PWM_COUNT_MODE = (0)
PWM_CONTINUE_MODE = (1)
RoBoIO.pwmdx_SetWaveform.argtypes = [c_int, c_int]
RoBoIO.pwmdx_SetWaveform.restype = None
pwmdx_SetWaveform = RoBoIO.pwmdx_SetWaveform

PWM_WAVEFORM_NORMAL = (0)
PWM_WAVEFORM_INVERSE = (1)
RoBoIO.pwmdx_SetPulseCount.argtypes = [c_int, c_uint]
RoBoIO.pwmdx_SetPulseCount.restype = None
pwmdx_SetPulseCount = RoBoIO.pwmdx_SetPulseCount

RoBoIO.pwmdx_SetCtrlREG.argtypes = [c_int, c_uint]
RoBoIO.pwmdx_SetCtrlREG.restype = None
pwmdx_SetCtrlREG = RoBoIO.pwmdx_SetCtrlREG

RoBoIO.pwmdx_SetHREG.argtypes = [c_int, c_uint]
RoBoIO.pwmdx_SetHREG.restype = None
pwmdx_SetHREG = RoBoIO.pwmdx_SetHREG

RoBoIO.pwmdx_SetLREG.argtypes = [c_int, c_uint]
RoBoIO.pwmdx_SetLREG.restype = None
pwmdx_SetLREG = RoBoIO.pwmdx_SetLREG

RoBoIO.pwmdx_ReadPulseCount.argtypes = [c_int]
RoBoIO.pwmdx_ReadPulseCount.restype = c_uint
pwmdx_ReadPulseCount = RoBoIO.pwmdx_ReadPulseCount

RoBoIO.pwmdx_ReadCtrlREG.argtypes = [c_int]
RoBoIO.pwmdx_ReadCtrlREG.restype = c_uint
pwmdx_ReadCtrlREG = RoBoIO.pwmdx_ReadCtrlREG

RoBoIO.pwmdx_ReadHREG.argtypes = [c_int]
RoBoIO.pwmdx_ReadHREG.restype = c_uint
pwmdx_ReadHREG = RoBoIO.pwmdx_ReadHREG

RoBoIO.pwmdx_ReadLREG.argtypes = [c_int]
RoBoIO.pwmdx_ReadLREG.restype = c_uint
pwmdx_ReadLREG = RoBoIO.pwmdx_ReadLREG

RoBoIO.pwm_SetSyncREG.argtypes = [c_uint]
RoBoIO.pwm_SetSyncREG.restype = None
pwm_SetSyncREG = RoBoIO.pwm_SetSyncREG

RoBoIO.pwm_SetINTREG.argtypes = [c_uint]
RoBoIO.pwm_SetINTREG.restype = None
pwm_SetINTREG = RoBoIO.pwm_SetINTREG

RoBoIO.pwm_ReadSyncREG.argtypes = None
RoBoIO.pwm_ReadSyncREG.restype = c_uint
pwm_ReadSyncREG = RoBoIO.pwm_ReadSyncREG

RoBoIO.pwm_ReadINTREG.argtypes = None
RoBoIO.pwm_ReadINTREG.restype = c_uint
pwm_ReadINTREG = RoBoIO.pwm_ReadINTREG

RoBoIO.pwm_SetPWMSettingREG.argtypes = [c_uint]
RoBoIO.pwm_SetPWMSettingREG.restype = None
pwm_SetPWMSettingREG = RoBoIO.pwm_SetPWMSettingREG

RoBoIO.pwm_ReadPWMSettingREG.argtypes = None
RoBoIO.pwm_ReadPWMSettingREG.restype = c_uint
pwm_ReadPWMSettingREG = RoBoIO.pwm_ReadPWMSettingREG

#spi.h
RoBoIO.spi_InUse.argtypes = None
RoBoIO.spi_InUse.restype = c_bool
spi_InUse = RoBoIO.spi_InUse

RoBoIO.spi_Init2.argtypes = [c_uint, c_int]
RoBoIO.spi_Init2.restype = c_bool
spi_Init2 = RoBoIO.spi_Init2

SPICLK_21400KHZ = (0)
SPICLK_18750KHZ = (1)
SPICLK_15000KHZ = (2)
SPICLK_12500KHZ = (3)
SPICLK_10000KHZ = (4)
SPICLK_10714KHZ = (5)
SPICLK_11538KHZ = (6)
SPICLK_13636KHZ = (7)
SPICLK_16666KHZ = (8)
SPICLK_25000KHZ = (9)
SPICLK_30000KHZ = (10)
SPICLK_37000KHZ = (11)
SPICLK_50000KHZ = (12)
SPICLK_75000KHZ = (13)
SPICLK_150000KHZ = (14)
ERROR_SPI_INUSE = (ERR_NOERROR + 200)
ERROR_SPI_INITFAIL = (ERR_NOERROR + 202)
RoBoIO.spi_Close.argtypes = None
RoBoIO.spi_Close.restype = None
spi_Close = RoBoIO.spi_Close

RoBoIO.spi_InitSW.argtypes = [c_int, c_uint]
RoBoIO.spi_InitSW.restype = c_bool
spi_InitSW = RoBoIO.spi_InitSW

SPIMODE_CPOL0 = (0x00)
SPIMODE_CPOL1 = (0x04)
SPIMODE_SMOD0 = (0x00)
SPIMODE_SMOD1 = (0x02)
SPIMODE_CPHA0 = (0x00)
SPIMODE_CPHA1 = (0x01)
ERROR_SPISW_INVALIDMODE = (ERR_NOERROR + 230)
RoBoIO.spi_CloseSW.argtypes = None
RoBoIO.spi_CloseSW.restype = None
spi_CloseSW = RoBoIO.spi_CloseSW

RoBoIO.spi_Write.argtypes = [c_ubyte]
RoBoIO.spi_Write.restype = c_bool
spi_Write = RoBoIO.spi_Write

RoBoIO.spi_WriteFlush.argtypes = [c_ubyte]
RoBoIO.spi_WriteFlush.restype = c_bool
spi_WriteFlush = RoBoIO.spi_WriteFlush

RoBoIO.spi_FIFOFlush.argtypes = None
RoBoIO.spi_FIFOFlush.restype = c_bool
spi_FIFOFlush = RoBoIO.spi_FIFOFlush

RoBoIO.spi_Read.argtypes = None
RoBoIO.spi_Read.restype = c_uint
spi_Read = RoBoIO.spi_Read

RoBoIO.spi_Read2.argtypes = None
RoBoIO.spi_Read2.restype = c_uint
spi_Read2 = RoBoIO.spi_Read2

RoBoIO.spi_ReadStrict.argtypes = None
RoBoIO.spi_ReadStrict.restype = c_uint
spi_ReadStrict = RoBoIO.spi_ReadStrict

RoBoIO.spi_Exchange.argtypes = [c_ubyte]
RoBoIO.spi_Exchange.restype = c_uint
spi_Exchange = RoBoIO.spi_Exchange

RoBoIO.spi_EnableSS.argtypes = None
RoBoIO.spi_EnableSS.restype = c_bool
spi_EnableSS = RoBoIO.spi_EnableSS

RoBoIO.spi_DisableSS.argtypes = None
RoBoIO.spi_DisableSS.restype = c_bool
spi_DisableSS = RoBoIO.spi_DisableSS

ERROR_SPI_UNSUPPORTED = (ERR_NOERROR + 220)
RoBoIO.spi_Init.argtypes = [c_int]
RoBoIO.spi_Init.restype = c_bool
spi_Init = RoBoIO.spi_Init

RoBoIO.spi_Initialize.argtypes = [c_int]
RoBoIO.spi_Initialize.restype = c_bool
spi_Initialize = RoBoIO.spi_Initialize

RoBoIO.spi_InitializeSW.argtypes = [c_int, c_uint]
RoBoIO.spi_InitializeSW.restype = c_bool
spi_InitializeSW = RoBoIO.spi_InitializeSW

#spidx.h
RoBoIO.spi_SetBaseAddress.argtypes = [c_uint]
RoBoIO.spi_SetBaseAddress.restype = None
spi_SetBaseAddress = RoBoIO.spi_SetBaseAddress

RoBoIO.spi_SetDefaultBaseAddress.argtypes = None
RoBoIO.spi_SetDefaultBaseAddress.restype = c_uint
spi_SetDefaultBaseAddress = RoBoIO.spi_SetDefaultBaseAddress

RoBoIO.spi_SetControlREG.argtypes = [c_ubyte]
RoBoIO.spi_SetControlREG.restype = c_bool
spi_SetControlREG = RoBoIO.spi_SetControlREG

ERROR_SPIBUSY = (ERR_NOERROR + 210)
RoBoIO.spi_SetErrorREG.argtypes = [c_ubyte]
RoBoIO.spi_SetErrorREG.restype = None
spi_SetErrorREG = RoBoIO.spi_SetErrorREG

RoBoIO.spi_ReadControlREG.argtypes = None
RoBoIO.spi_ReadControlREG.restype = c_ubyte
spi_ReadControlREG = RoBoIO.spi_ReadControlREG

RoBoIO.spi_ReadStatusREG.argtypes = None
RoBoIO.spi_ReadStatusREG.restype = c_ubyte
spi_ReadStatusREG = RoBoIO.spi_ReadStatusREG

RoBoIO.spi_ReadCSREG.argtypes = None
RoBoIO.spi_ReadCSREG.restype = c_ubyte
spi_ReadCSREG = RoBoIO.spi_ReadCSREG

RoBoIO.spi_ReadErrorREG.argtypes = None
RoBoIO.spi_ReadErrorREG.restype = c_ubyte
spi_ReadErrorREG = RoBoIO.spi_ReadErrorREG

RoBoIO.spi_EnableFIFO.argtypes = None
RoBoIO.spi_EnableFIFO.restype = c_bool
spi_EnableFIFO = RoBoIO.spi_EnableFIFO

RoBoIO.spi_DisableFIFO.argtypes = None
RoBoIO.spi_DisableFIFO.restype = c_bool
spi_DisableFIFO = RoBoIO.spi_DisableFIFO

RoBoIO.spi_SetClockDivisor.argtypes = [c_ubyte]
RoBoIO.spi_SetClockDivisor.restype = c_bool
spi_SetClockDivisor = RoBoIO.spi_SetClockDivisor

ERROR_SPIWRONGCLOCK = (ERR_NOERROR + 211)
RoBoIO.spi_InputReady.argtypes = None
RoBoIO.spi_InputReady.restype = c_bool
spi_InputReady = RoBoIO.spi_InputReady

RoBoIO.spi_OutputFIFOEmpty.argtypes = None
RoBoIO.spi_OutputFIFOEmpty.restype = c_bool
spi_OutputFIFOEmpty = RoBoIO.spi_OutputFIFOEmpty

RoBoIO.spi_OutputFIFOFull.argtypes = None
RoBoIO.spi_OutputFIFOFull.restype = c_bool
spi_OutputFIFOFull = RoBoIO.spi_OutputFIFOFull

RoBoIO.spi_Busy.argtypes = None
RoBoIO.spi_Busy.restype = c_bool
spi_Busy = RoBoIO.spi_Busy

RoBoIO.spierror_SPIBusy.argtypes = None
RoBoIO.spierror_SPIBusy.restype = c_bool
spierror_SPIBusy = RoBoIO.spierror_SPIBusy

RoBoIO.spierror_InputOverlap.argtypes = None
RoBoIO.spierror_InputOverlap.restype = c_bool
spierror_InputOverlap = RoBoIO.spierror_InputOverlap

RoBoIO.spierror_FIFOUnderrun.argtypes = None
RoBoIO.spierror_FIFOUnderrun.restype = c_bool
spierror_FIFOUnderrun = RoBoIO.spierror_FIFOUnderrun

RoBoIO.spierror_FIFOOverrun.argtypes = None
RoBoIO.spierror_FIFOOverrun.restype = c_bool
spierror_FIFOOverrun = RoBoIO.spierror_FIFOOverrun

RoBoIO.spierror_ClearSPIBusy.argtypes = None
RoBoIO.spierror_ClearSPIBusy.restype = None
spierror_ClearSPIBusy = RoBoIO.spierror_ClearSPIBusy

RoBoIO.spierror_ClearInputOverlap.argtypes = None
RoBoIO.spierror_ClearInputOverlap.restype = None
spierror_ClearInputOverlap = RoBoIO.spierror_ClearInputOverlap

RoBoIO.spierror_ClearFIFOUnderrun.argtypes = None
RoBoIO.spierror_ClearFIFOUnderrun.restype = None
spierror_ClearFIFOUnderrun = RoBoIO.spierror_ClearFIFOUnderrun

RoBoIO.spierror_ClearFIFOOverrun.argtypes = None
RoBoIO.spierror_ClearFIFOOverrun.restype = None
spierror_ClearFIFOOverrun = RoBoIO.spierror_ClearFIFOOverrun

RoBoIO.spi_ClearErrors.argtypes = None
RoBoIO.spi_ClearErrors.restype = None
spi_ClearErrors = RoBoIO.spi_ClearErrors

RoBoIO.spidx_Write.argtypes = [c_ubyte]
RoBoIO.spidx_Write.restype = c_bool
spidx_Write = RoBoIO.spidx_Write

RoBoIO.spidx_WriteFlush.argtypes = [c_ubyte]
RoBoIO.spidx_WriteFlush.restype = c_bool
spidx_WriteFlush = RoBoIO.spidx_WriteFlush

ERROR_SPIFIFOFULL = (ERR_NOERROR + 214)
ERROR_SPIFIFOFAIL = (ERR_NOERROR + 215)
RoBoIO.spidx_FIFOFlush.argtypes = None
RoBoIO.spidx_FIFOFlush.restype = c_bool
spidx_FIFOFlush = RoBoIO.spidx_FIFOFlush

RoBoIO.spidx_Read.argtypes = None
RoBoIO.spidx_Read.restype = c_uint
spidx_Read = RoBoIO.spidx_Read

ERROR_SPIREADFAIL = (ERR_NOERROR + 219)
RoBoIO.spidx_Read2.argtypes = None
RoBoIO.spidx_Read2.restype = c_uint
spidx_Read2 = RoBoIO.spidx_Read2

RoBoIO.spidx_ReadStrict.argtypes = None
RoBoIO.spidx_ReadStrict.restype = c_uint
spidx_ReadStrict = RoBoIO.spidx_ReadStrict
